'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Apps = require('../Apps');

var _Button = require('../Button');

var _Headline = require('../Headline');

var _Media = require('../Media');

var _Modal = require('../Modal');

var _Text = require('../Text');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function AppModal(_ref) {
  var title = _ref.title,
      description = _ref.description,
      children = _ref.children,
      open = _ref.open,
      onClose = _ref.onClose,
      iconSrc = _ref.iconSrc,
      closeLabel = _ref.closeLabel,
      actions = _ref.actions;

  return _react2.default.createElement(
    _Modal.Modal,
    { open: open, onClose: onClose },
    _react2.default.createElement(
      _Modal.ModalHeader,
      null,
      _react2.default.createElement(
        _Media.Media,
        null,
        _react2.default.createElement(
          _Media.MediaContent,
          null,
          _react2.default.createElement(
            _Headline.Headline,
            { size: 'medium' },
            title
          ),
          _react2.default.createElement(
            _Text.Text,
            { muted: true, block: true, margin: '1xt' },
            description
          ),
          closeLabel && _react2.default.createElement(
            _Button.Button,
            { margin: '1xt', onClick: onClose },
            closeLabel
          )
        ),
        _react2.default.createElement(
          _Media.MediaIcon,
          null,
          _react2.default.createElement(_Apps.AppIcon, { src: iconSrc })
        )
      ),
      actions
    ),
    _react2.default.createElement(
      _Modal.ModalContent,
      null,
      children
    )
  );
}

AppModal.propTypes = {
  children: _react2.default.PropTypes.any,
  closeLabel: _react2.default.PropTypes.string,
  description: _react2.default.PropTypes.string,
  iconSrc: _react2.default.PropTypes.string,
  onClose: _react2.default.PropTypes.func.isRequired,
  open: _react2.default.PropTypes.bool,
  title: _react2.default.PropTypes.string,
  actions: _react2.default.PropTypes.any
};

AppModal.defaultProps = {
  closeLabel: null
};

exports.default = AppModal;