'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../Spacing/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function BoxContent(props) {
  var borderBottom = props.borderBottom,
      children = props.children,
      noPadding = props.noPadding,
      theme = props.theme,
      transparent = props.transparent,
      padding = props.padding;


  var className = (0, _classnames2.default)('ui-box-content', 'ui-box-content-theme-' + theme, {
    'ui-box-content-no-padding': noPadding,
    'ui-box-content-transparent': transparent,
    'ui-box-content-border-bottom': borderBottom
  });

  var style = (0, _utils.spacingStyles)({ padding: padding });

  return _react2.default.createElement(
    'div',
    { className: className, style: style },
    children
  );
}

BoxContent.propTypes = {
  borderBottom: _react2.default.PropTypes.bool,
  children: _react2.default.PropTypes.node,
  noPadding: _react2.default.PropTypes.bool,
  theme: _react2.default.PropTypes.oneOf(['default', 'shade']).isRequired,
  transparent: _react2.default.PropTypes.bool,
  padding: _react2.default.PropTypes.string
};

BoxContent.defaultProps = {
  borderBottom: false,
  children: null,
  noPadding: false,
  theme: 'default',
  transparent: false
};

exports.default = BoxContent;