'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function BoxHeader(_ref) {
  var noPadding = _ref.noPadding,
      compact = _ref.compact,
      children = _ref.children,
      center = _ref.center;

  var className = (0, _classnames2.default)('ui-box-header', {
    'ui-box-header-no-padding': noPadding,
    'ui-box-header-compact': compact,
    'ui-box-header-center': center
  });

  return _react2.default.createElement(
    'div',
    { className: className },
    children
  );
}

BoxHeader.propTypes = {
  children: _react2.default.PropTypes.node,

  // Specifies whether padding should be removed
  noPadding: _react2.default.PropTypes.bool,
  compact: _react2.default.PropTypes.bool,
  center: _react2.default.PropTypes.bool
};

exports.default = BoxHeader;