'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _BreadcrumbItem = require('./BreadcrumbItem');

var _BreadcrumbItem2 = _interopRequireDefault(_BreadcrumbItem);

var _BreadcrumbSeparator = require('./BreadcrumbSeparator');

var _BreadcrumbSeparator2 = _interopRequireDefault(_BreadcrumbSeparator);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Breadcrumb = function Breadcrumb(props) {
  var children = props.children,
      embedded = props.embedded;

  var childrenArray = [].concat(children).filter(function (child) {
    return child !== null;
  });
  var childrenCount = childrenArray.length;
  var childrenWithCarets = (0, _lodash.flatten)(childrenArray.map(function (child, index) {
    var isParent = childrenCount > 1 && index < childrenCount - 1;
    var updatedChildProps = (0, _utils.merge)(child.props, {
      parent: isParent
    });
    var result = [_react2.default.createElement(_BreadcrumbItem2.default, updatedChildProps)];
    if (isParent) {
      result.push(_react2.default.createElement(_BreadcrumbSeparator2.default, null));
    }
    return result;
  })).map(function (child, index) {
    var ChildType = child.type;
    var propsWithIndex = (0, _utils.merge)(child.props, { key: index });
    return _react2.default.createElement(ChildType, propsWithIndex);
  });

  var className = (0, _classnames2.default)('ui-breadcrumb', {
    'ui-breadcrumb-embedded': embedded
  });

  return _react2.default.createElement(
    'div',
    { className: className },
    childrenWithCarets
  );
};

Breadcrumb.propTypes = {
  children: _react2.default.PropTypes.node,

  // Specifies whether the breadcrumb should appear embedded
  embedded: _react2.default.PropTypes.bool
};

exports.default = Breadcrumb;