'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BreadcrumbItem = function BreadcrumbItem(props) {
  var parent = props.parent,
      active = props.active,
      label = props.label,
      linkBuilder = props.link;

  var className = (0, _classnames2.default)('ui-breadcrumb-item', {
    'ui-breadcrumb-item-active': active,
    'ui-breadcrumb-item-parent': parent
  });
  var content = linkBuilder ? linkBuilder(label) : label;

  return _react2.default.createElement(
    'div',
    { className: className },
    content
  );
};

BreadcrumbItem.propTypes = {
  // Defines whether this crumb is active
  active: _react2.default.PropTypes.bool,

  // Defines the displayed text
  label: _react2.default.PropTypes.string.isRequired,

  // Defines whether this item is a parent item (and should then be styled
  // differently)
  parent: _react2.default.PropTypes.bool,

  // If specified, this is called to build a link inside the item
  link: _react2.default.PropTypes.func
};

exports.default = BreadcrumbItem;