'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactTooltip = require('react-tooltip');

var _reactTooltip2 = _interopRequireDefault(_reactTooltip);

var _utils = require('../../utils');

var _Icon = require('../Icon');

var _Dropdown = require('../Dropdown');

var _Spinner = require('../Spinner');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_Component) {
  _inherits(Button, _Component);

  function Button(props) {
    _classCallCheck(this, Button);

    var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

    _this.setDropdownRef = function (element) {
      if (element) {
        _this.dropdownWrapper = element;
      }
    };

    _this.handleDocumentClick = function (event) {
      if (!_this.dropdownWrapper.contains(event.target)) {
        _this.setState({
          dropdownOpen: false
        });
      }
    };

    _this.id = (0, _utils.randomString)(10);

    _this.state = {
      // Tracks the open state of the dropdown
      dropdownOpen: false
    };
    return _this;
  }

  _createClass(Button, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var dropdown = this.props.dropdown;

      // If the button should open a dropdown, we register a handler that
      // listens to all clicks on the document.

      if (dropdown) {
        document.addEventListener('click', this.handleDocumentClick, true);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var dropdown = this.props.dropdown;

      // Remove the event listener

      if (dropdown) {
        document.removeEventListener('click', this.handleDocumentClick, true);
      }
    }

    /**
     * This checks whether the clicked event target is a child of
     * the dropdown wrapper. If not it is considered to be an outside click
     * and closes the dropdown.
     */

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          block = _props.block,
          children = _props.children,
          originalClassName = _props.className,
          confirmMessage = _props.confirmMessage,
          description = _props.description,
          originalDisabled = _props.disabled,
          originalDropdown = _props.dropdown,
          highlight = _props.highlight,
          originalIcon = _props.icon,
          iconSize = _props.iconSize,
          large = _props.large,
          left = _props.left,
          originalLInk = _props.link,
          loading = _props.loading,
          margin = _props.margin,
          originialOnClick = _props.onClick,
          small = _props.small,
          suffixIcon = _props.suffixIcon,
          theme = _props.theme,
          tooltip = _props.tooltip,
          type = _props.type,
          hidden = _props.hidden,
          borderRightWidth = _props.borderRightWidth,
          notify = _props.notify,
          smallPadding = _props.smallPadding;
      var dropdownOpen = this.state.dropdownOpen;


      var disabled = originalDisabled || loading;
      var icon = originalIcon || (loading ? 'circle-o-notch' : null);
      var iconOnly = !children && icon;

      // If a dropdown is given, it must be enhanced with the local
      // open/closed state
      var newProps = {
        open: dropdownOpen,
        onItemClick: function onItemClick() {
          return _this2.setState({ dropdownOpen: false });
        }
      };
      var dropdownProps = originalDropdown && _extends({}, originalDropdown.props, newProps);
      var dropdown = originalDropdown && _react2.default.createElement(_Dropdown.Dropdown, dropdownProps);

      // If a dropdown is specified, the onClick can be overwritten
      // to update the state
      var onClick = dropdown ? function () {
        _this2.setState(function (state) {
          return { dropdownOpen: !state.dropdownOpen };
        });
      } : originialOnClick;

      // If an icon name is specified, a prepend must be added
      var prependClassName = (0, _classnames2.default)('ui-button-prepend', {
        'ui-button-prepend-no-margin': iconOnly
      });
      var prepend = icon && _react2.default.createElement(
        'span',
        { className: prependClassName },
        loading ? _react2.default.createElement(_Spinner.Spinner, null) : _react2.default.createElement(_Icon.Icon, { name: icon, size: iconSize })
      );

      // If a dropdown is specified, a append must be specified which
      // displays a caert
      var append = (dropdown && !icon || suffixIcon) && _react2.default.createElement(
        'span',
        { className: (0, _classnames2.default)('ui-button-append') },
        dropdown && !icon && _react2.default.createElement(_Icon.Icon, { name: 'caret-down' }),
        suffixIcon && _react2.default.createElement(_Icon.Icon, { name: suffixIcon })
      );

      var className = (0, _classnames2.default)('ui-button', 'ui-button-type-' + theme, {
        'ui-button-size-small': small,
        'ui-button-size-large': large,
        'ui-button-size-block': block,
        'ui-button-state-disabled': disabled,
        'ui-button-state-loading': loading,
        'ui-button-left': left,
        'ui-button-highlight': highlight,
        'ui-button-size-small-padding': smallPadding
      }, originalClassName);

      var onClickWrapper = function onClickWrapper(event) {
        if (disabled) {
          return false;
        }

        var performOnClick = function performOnClick() {
          // we stop event propagation to ensure that other components
          // do not receive this onClick as an onClick.
          event.stopPropagation();
          onClick(event);
        };

        if (confirmMessage) {
          // eslint-disable-next-line
          if (window.confirm(confirmMessage)) {
            return performOnClick();
          }

          return false;
        }

        return performOnClick();
      };

      var inner = _react2.default.createElement(
        'span',
        { className: (0, _classnames2.default)('ui-button-inner') },
        prepend,
        children && _react2.default.createElement(
          'span',
          { className: (0, _classnames2.default)('ui-button-content') },
          children,
          description && _react2.default.createElement(
            'span',
            { className: (0, _classnames2.default)('ui-button-description') },
            description
          )
        ),
        append
      );

      var style = (0, _utils.spacing)({ margin: margin });

      if (hidden) {
        style = (0, _utils.merge)(style, { display: "none" });
      }

      if (borderRightWidth) {
        style = (0, _utils.merge)(style, { "border-right-width": "1px" });
      }

      var link = originalLInk;
      if (link) {
        link = link(inner);
        var LinkType = link.type;
        var linkProps = _extends({}, link.props, { className: className });
        link = _react2.default.createElement(LinkType, _extends({}, linkProps, { style: style, title: tooltip }));
      }

      var id = 'button-' + this.id;

      var button = link || _react2.default.createElement(
        'button',
        {
          type: type,
          onClick: onClickWrapper,
          className: className,
          value: this.props.value,
          style: style,
          'data-tip': true,
          'data-for': id
        },
        inner,
        tooltip && _react2.default.createElement(
          _reactTooltip2.default,
          { effect: 'solid', id: id },
          tooltip
        ),
        notify && _react2.default.createElement(
          'span',
          { className: 'ui-notify' },
          notify
        )
      );

      var dropdownClassName = (0, _classnames2.default)('ui-dropdown-wrapper', {
        'ui-dropdown-wrapper-block': block
      });

      if (dropdown) {
        return _react2.default.createElement(
          'div',
          { ref: this.setDropdownRef, className: dropdownClassName },
          button,
          dropdown
        );
      }

      return button;
    }
  }]);

  return Button;
}(_react.Component);

Button.propTypes = {
  block: _react2.default.PropTypes.bool.isRequired,
  children: _react2.default.PropTypes.node,
  className: _react2.default.PropTypes.string,
  confirmMessage: _react2.default.PropTypes.node,
  description: _react2.default.PropTypes.string,
  disabled: _react2.default.PropTypes.bool,
  dropdown: _react2.default.PropTypes.object,
  icon: _react2.default.PropTypes.string,
  iconSize: _react2.default.PropTypes.string,
  highlight: _react2.default.PropTypes.bool,
  large: _react2.default.PropTypes.bool,
  left: _react2.default.PropTypes.bool,
  link: _react2.default.PropTypes.func,
  loading: _react2.default.PropTypes.bool.isRequired,
  margin: _react2.default.PropTypes.string,
  onClick: _react2.default.PropTypes.func.isRequired,
  small: _react2.default.PropTypes.bool.isRequired,
  suffixIcon: _react2.default.PropTypes.string,
  theme: _react2.default.PropTypes.string.isRequired,
  tooltip: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.bool]),
  type: _react2.default.PropTypes.string.isRequired,
  value: _react2.default.PropTypes.string,
  hidden: _react2.default.PropTypes.bool.isRequired,
  borderRightWidth: _react2.default.PropTypes.bool.isRequired,
  smallPadding: _react2.default.PropTypes.bool.isRequired,
  notify: _react2.default.PropTypes.string
};

Button.defaultProps = {
  block: false,
  disabled: false,
  highlight: false,
  iconSize: 'default',
  loading: false,
  onClick: function onClick() {},
  small: false,
  theme: 'default',
  type: 'button',
  hidden: false,
  borderRightWidth: false,
  smallPadding: false
};

exports.default = Button;