'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../Spacing/utils');

var _Button = require('../Button');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ButtonGroup(_ref) {
  var loose = _ref.loose,
      children = _ref.children,
      margin = _ref.margin,
      block = _ref.block,
      disabled = _ref.disabled;

  var style = (0, _utils.spacingStyles)({ margin: margin });
  var className = (0, _classnames2.default)('ui-buttongroup', {
    'ui-buttongroup-snap': !loose,
    'ui-buttongroup-block': block
  });

  // Only updates the children if required
  function updateChildsIfNecessary(childs) {
    if (!disabled) {
      return childs;
    }

    return [].concat(children).map(function (child, index) {
      if (child && child.type && child.type === _Button.Button) {
        var newProps = _extends({}, child.props, { key: index, disabled: disabled });
        return _react2.default.createElement(_Button.Button, newProps);
      } else if (child) {
        var ChildType = child.type;
        return _react2.default.createElement(ChildType, _extends({ key: index }, child.props));
      }

      return child;
    });
  }

  return _react2.default.createElement(
    'div',
    { className: className, style: style },
    updateChildsIfNecessary(children)
  );
}

ButtonGroup.propTypes = {
  children: _react2.default.PropTypes.node,
  loose: _react2.default.PropTypes.bool,
  block: _react2.default.PropTypes.bool,
  margin: _react2.default.PropTypes.string,
  disabled: _react2.default.PropTypes.bool
};

ButtonGroup.defaultProps = {
  disabled: false
};

exports.default = ButtonGroup;