'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Badge = require('../Badge');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function StatusBadge(_ref) {
  var value = _ref.value,
      trueLabel = _ref.trueLabel,
      falseLabel = _ref.falseLabel,
      showLabel = _ref.showLabel;

  var iconName = value ? 'check' : 'ban';
  var theme = value ? 'success' : 'info';
  var label = value ? trueLabel : falseLabel;

  return _react2.default.createElement(
    _Badge.Badge,
    { icon: !showLabel && iconName, tooltip: !showLabel && label, theme: theme },
    showLabel && label
  );
}

StatusBadge.propTypes = {
  value: _react2.default.PropTypes.bool.isRequired,
  trueLabel: _react2.default.PropTypes.string.isRequired,
  falseLabel: _react2.default.PropTypes.string.isRequired,
  showLabel: _react2.default.PropTypes.bool.isRequired
};

StatusBadge.defaultProps = {
  value: true,
  showLabel: false
};

exports.default = StatusBadge;