'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../Spacing/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Details(_ref) {
  var compact = _ref.compact,
      children = _ref.children,
      horizontal = _ref.horizontal,
      margin = _ref.margin;

  var className = (0, _classnames2.default)('ui-details', {
    'ui-details-compact': compact,
    'ui-details-horizontal': horizontal
  });

  var style = (0, _utils.spacingStyles)({ margin: margin });

  return _react2.default.createElement(
    'div',
    { className: className, style: style },
    children
  );
}

Details.propTypes = {
  children: _react2.default.PropTypes.node,
  compact: _react2.default.PropTypes.bool,
  horizontal: _react2.default.PropTypes.bool,
  margin: _react2.default.PropTypes.string
};

exports.default = Details;