'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function DropdownItem(props) {
  var title = props.title,
      focussed = props.focussed,
      onClick = props.onClick,
      icon = props.icon,
      image = props.image,
      description = props.description,
      body = props.body,
      children = props.children;


  var className = (0, _classnames2.default)('ui-dropdown-item', {
    'ui-dropdown-item-focussed': focussed
  });

  return _react2.default.createElement(
    'div',
    { className: className, onClick: onClick },
    icon && _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('ui-dropdown-item-icon') },
      (0, _lodash.isString)(icon) && _react2.default.createElement(_Icon.Icon, { name: icon }),
      !(0, _lodash.isString)(icon) && _react2.default.createElement(_Icon.Icon, { name: icon.name, set: icon.set, color: icon.color })
    ),
    image && _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('ui-dropdown-item-image') },
      image
    ),
    _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('ui-dropdown-item-content') },
      title && _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-dropdown-item-title') },
        title
      ),
      description && _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-dropdown-item-description') },
        description
      ),
      body && !children && _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-dropdown-item-body') },
        body
      ),
      children && !body && _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-dropdown-item-body') },
        children
      )
    )
  );
}

DropdownItem.propTypes = {
  title: _react2.default.PropTypes.node,
  description: _react2.default.PropTypes.string,
  body: _react2.default.PropTypes.object,
  children: _react2.default.PropTypes.node,
  icon: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.object]),
  onClick: _react2.default.PropTypes.func.isRequired,
  image: _react2.default.PropTypes.node,
  focussed: _react2.default.PropTypes.bool
};

DropdownItem.defaultProps = {
  onClick: function onClick() {},
  children: null
};

exports.default = DropdownItem;