'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactTooltip = require('react-tooltip');

var _reactTooltip2 = _interopRequireDefault(_reactTooltip);

var _utils = require('../../utils');

var _utils2 = require('../Spacing/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Flag(props) {
  var margin = props.margin,
      tooltip = props.tooltip,
      code = props.code,
      text = props.text;


  var styles = margin ? (0, _utils2.spacingStyles)({ margin: margin }) : {};

  var className = (0, _classnames2.default)('ui-flag', 'ui-flag-' + String(code).toLowerCase());

  var id = 'flag-' + (0, _utils.randomString)(10);

  var flag = _react2.default.createElement('span', { className: className });

  var tooltpMarkup = tooltip && _react2.default.createElement(
    _reactTooltip2.default,
    { effect: 'solid', id: id },
    tooltip
  );

  var flagWithText = text && _react2.default.createElement(
    'span',
    {
      className: (0, _classnames2.default)('ui-flag-wrapper'),
      style: styles,
      'data-tip': true,
      'data-for': id
    },
    flag,
    props.text,
    tooltpMarkup
  );

  var flagOnly = !text && _react2.default.createElement(
    'span',
    {
      style: styles,
      'data-tip': true,
      'data-for': id
    },
    flag,
    tooltpMarkup
  );

  return text ? flagWithText : flagOnly;
}

Flag.propTypes = {
  /**
   * The country code
   * @type {String}
   */
  code: _react2.default.PropTypes.string.isRequired,

  /**
   * An optional text
   * @type {String}
   */
  text: _react2.default.PropTypes.string,

  /**
   * Margin definition, e.g. `1xb`
   * @type {String}
   */
  margin: _react2.default.PropTypes.string,

  /**
   * An optional tooltip text
   * @type {String}
   */
  tooltip: _react2.default.PropTypes.string
};

exports.default = Flag;