'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../Spacing/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Flex(_ref) {
  var children = _ref.children,
      margin = _ref.margin,
      noPadding = _ref.noPadding,
      noWrap = _ref.noWrap;

  var style = (0, _utils.spacingStyles)({ margin: margin });

  var className = (0, _classnames2.default)('ui-flexgrid', {
    'ui-flexgrid-no-padding': noPadding,
    'ui-flexgrid-no-wrap': noWrap
  });

  var itemsClassName = (0, _classnames2.default)('ui-flexgrid-items');

  return _react2.default.createElement(
    'div',
    { className: className, style: style },
    _react2.default.createElement(
      'div',
      { className: itemsClassName },
      children
    )
  );
}

Flex.propTypes = {
  children: _react2.default.PropTypes.node,
  margin: _react2.default.PropTypes.string,

  /**
   * Specifies whether padding should be removed
   * @type {Boolean}
   */
  noPadding: _react2.default.PropTypes.bool,

  /**
   * Specifies whether wrapping should be disabled
   * @type {Boolean}
   */
  noWrap: _react2.default.PropTypes.bool
};

exports.default = Flex;