'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _Button = require('../Button');

var _Spinner = require('../Spinner');

var _Badge = require('../Badge');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = function (_Component) {
  _inherits(FormItem, _Component);

  _createClass(FormItem, null, [{
    key: 'shouldShowErrors',


    /**
     * Returns whether errors should be displayed
     */
    value: function shouldShowErrors(pristineValue, errors, state) {
      if (state && state.showError) {
        return true;
      }
      if (pristineValue === false) {
        return true;
      }
      if (state && !state.showError && !state.pristine && errors.length > 0) {
        return true;
      }

      return false;
    }
  }]);

  function FormItem(props) {
    _classCallCheck(this, FormItem);

    var _this = _possibleConstructorReturn(this, (FormItem.__proto__ || Object.getPrototypeOf(FormItem)).call(this, props));

    var pristine = props.pristine,
        errors = props.errors;


    _this.onChange = _this.onChange.bind(_this);

    _this.state = {
      // Specifies that this field was never touched and thus should not display
      // any errors, regardless if they exist.
      pristine: pristine,

      // Specifieds whether errors should be shown.
      showErrors: FormItem.shouldShowErrors(pristine, errors, _this.state)
    };
    return _this;
  }

  /**
   * Checkes the next props and decides whether errors should be shown.
   */


  _createClass(FormItem, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var pristine = nextProps.pristine,
          errors = nextProps.errors;


      var shouldShowErrors = FormItem.shouldShowErrors(pristine, errors, this.state);

      if (shouldShowErrors && shouldShowErrors !== this.state.showErrors) {
        this.setState({ showErrors: true });
      }
    }
  }, {
    key: 'isCheckboxDefault',
    value: function isCheckboxDefault() {
      var type = this.props.type;

      return type == 'checkbox-default';
    }
  }, {
    key: 'onChange',
    value: function onChange(newValue) {
      var onChange = this.props.onChange;

      var guardRegex = this.getGuardRegex();

      this.setState({ pristine: false });

      if (guardRegex) {
        if (String(newValue).match(guardRegex)) {
          onChange(newValue);
        }
      } else {
        onChange(newValue);
      }
    }
  }, {
    key: 'getGuardRegex',
    value: function getGuardRegex() {
      var guard = this.props.guard;


      switch (guard) {
        case 'decimal':
          return (/^$|^-?[0-9]+[.,]?([0-9]*)+$/
          );

        case 'number':
          return (/^-?[0-9]*$/
          );

        case 'posNumber':
          return (/^[0-9]*$/
          );

        default:
          return null;
      }
    }
  }, {
    key: 'renderErrors',
    value: function renderErrors() {
      var _props = this.props,
          errors = _props.errors,
          hideErrorMessage = _props.hideErrorMessage;
      var showErrors = this.state.showErrors;


      return !hideErrorMessage && errors.length > 0 && showErrors && _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-form-item-errors') },
        errors.map(function (error, index) {
          return _react2.default.createElement(
            'div',
            { key: index, className: (0, _classnames2.default)('ui-form-error') },
            error.message
          );
        })
      );
    }
  }, {
    key: 'renderLabel',
    value: function renderLabel() {
      var _props2 = this.props,
          label = _props2.label,
          required = _props2.required,
          requiredText = _props2.requiredText,
          labelAddon = _props2.labelAddon,
          labelNote = _props2.labelNote,
          bold = _props2.bold;


      if (!label) {
        return null;
      }

      if (this.isCheckboxDefault()) {
        var classNameLabel = (0, _classnames2.default)("ui-form-label-checkbox-default", { 'ui-form-label-bold': bold });
        return _react2.default.createElement(
          'div',
          { className: classNameLabel },
          label
        );
      } else {
        return _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-form-label') },
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)('ui-form-label-text') },
            label,
            labelNote && _react2.default.createElement(
              'div',
              { className: (0, _classnames2.default)('ui-form-label-note') },
              labelNote
            )
          ),
          required && _react2.default.createElement(
            'div',
            { className: 'ui-form-label-required' },
            _react2.default.createElement(
              _Badge.Badge,
              { theme: 'info' },
              requiredText
            )
          ),
          labelAddon && _react2.default.createElement(
            'div',
            { className: 'ui-form-label-addon' },
            labelAddon
          )
        );
      }
    }
  }, {
    key: 'renderTextControl',
    value: function renderTextControl() {
      var _onChange = this.onChange;
      var _props3 = this.props,
          type = _props3.type,
          value = _props3.value,
          defaultValue = _props3.defaultValue,
          tabIndex = _props3.tabIndex,
          placeholder = _props3.placeholder,
          disabled = _props3.disabled,
          controlRef = _props3.controlRef,
          hide = _props3.hide,
          width = _props3.width,
          allowShowZero = _props3.allowShowZero;

      var classNames = (0, _classnames2.default)('ui-form-control', 'ui-form-input-width-' + width);
      var valueInput = allowShowZero ? value : value || "";

      var input = _react2.default.createElement('input', {
        type: type,
        onChange: function onChange(event) {
          return _onChange(event.target.value);
        },
        value: valueInput,
        defaultValue: defaultValue,
        tabIndex: tabIndex,
        placeholder: placeholder,
        disabled: disabled || hide,
        ref: controlRef,
        className: classNames
      });

      return input;
    }
  }, {
    key: 'renderSelectControl',
    value: function renderSelectControl() {
      var _props4 = this.props,
          value = _props4.value,
          tabIndex = _props4.tabIndex,
          disabled = _props4.disabled,
          options = _props4.options,
          controlRef = _props4.controlRef,
          forceUpdate = _props4.forceUpdate;
      var _onChange2 = this.onChange;


      var valueProp = forceUpdate ? { value: value } : {};

      var input = _react2.default.createElement(
        'select',
        _extends({
          onChange: function onChange(event) {
            return _onChange2(event.target.value);
          },
          disabled: disabled,
          className: (0, _classnames2.default)('ui-form-control'),
          tabIndex: tabIndex,
          defaultValue: value,
          ref: controlRef
        }, valueProp),
        options.map(function (option, index) {
          return _react2.default.createElement(
            'option',
            { value: option.value, key: index, disabled: option.disabled },
            option.label
          );
        })
      );

      return input;
    }
  }, {
    key: 'renderTextAreaControl',
    value: function renderTextAreaControl() {
      var _props5 = this.props,
          value = _props5.value,
          defaultValue = _props5.defaultValue,
          tabIndex = _props5.tabIndex,
          disabled = _props5.disabled,
          controlRef = _props5.controlRef;
      var _onChange3 = this.onChange;


      var input = _react2.default.createElement('textarea', {
        onChange: function onChange(event) {
          return _onChange3(event.target.value);
        },
        value: value || '',
        defaultValue: defaultValue,
        tabIndex: tabIndex,
        disabled: disabled,
        ref: controlRef,
        className: (0, _classnames2.default)('ui-form-control')
      });

      return input;
    }
  }, {
    key: 'renderCheckboxControl',
    value: function renderCheckboxControl() {
      var _props6 = this.props,
          value = _props6.value,
          tabIndex = _props6.tabIndex,
          disabled = _props6.disabled,
          controlRef = _props6.controlRef;
      var _onChange4 = this.onChange;


      var input = _react2.default.createElement('input', {
        onChange: function onChange(event) {
          return _onChange4(event.target.checked);
        },
        checked: !!value,
        tabIndex: tabIndex,
        type: 'checkbox',
        disabled: disabled,
        ref: controlRef,
        className: (0, _classnames2.default)('ui-form-control')
      });

      return input;
    }
  }, {
    key: 'renderStaticControl',
    value: function renderStaticControl() {
      var children = this.props.children;


      return children;
    }
  }, {
    key: 'renderCustomControl',
    value: function renderCustomControl() {
      var _props7 = this.props,
          value = _props7.value,
          element = _props7.element;
      var elementProps = element.props,
          ElementType = element.type;

      // Inject the correct value and onChange into the element

      var newProps = _extends({}, elementProps, {
        onChange: this.onChange,
        value: value || ''
      });

      return _react2.default.createElement(ElementType, newProps);
    }
  }, {
    key: 'renderControl',
    value: function renderControl() {
      var _props8 = this.props,
          type = _props8.type,
          element = _props8.element;


      if (element) {
        return this.renderCustomControl();
      }

      switch (type) {

        case 'text':
        case 'password':
          return this.renderTextControl();

        case 'select':
          return this.renderSelectControl();

        case 'textarea':
        case 'rte':
          return this.renderTextAreaControl();

        case 'checkbox-default':
        case 'checkbox':
          return this.renderCheckboxControl();

        case 'static':
          return this.renderStaticControl();

        default:
          return _react2.default.createElement(
            'span',
            null,
            'Unknown element ',
            type
          );
      }
    }
  }, {
    key: 'renderInput',
    value: function renderInput() {
      var _props9 = this.props,
          addon = _props9.addon,
          description = _props9.description,
          dropdown = _props9.dropdown,
          errors = _props9.errors,
          innerAddon = _props9.innerAddon,
          prefix = _props9.prefix,
          spinner = _props9.spinner,
          suffix = _props9.suffix,
          right = _props9.right;
      var showErrors = this.state.showErrors;


      var className = (0, _classnames2.default)('ui-form-input', {
        'ui-form-input-with-errors': errors.length > 0 && showErrors
      });

      var prefixClassName = (0, _classnames2.default)('ui-form-control-group-prefix', prefix && {
        'ui-form-control-group-content-text': (0, _lodash.isString)(prefix),
        'ui-form-control-group-content-button': prefix.type === _Button.Button
      });

      var suffixClassName = (0, _classnames2.default)('ui-form-control-group-suffix', suffix && {
        'ui-form-control-group-content-text': (0, _lodash.isString)(suffix),
        'ui-form-control-group-content-button': suffix.type === _Button.Button,
        'ui-form-control-group-content-buttongroup': suffix.type === _Button.ButtonGroup
      });

      var controlGroupWrapperClassName = (0, _classnames2.default)('ui-form-control-group-wrapper', {
        'ui-form-control-group-wrapper-with-addon': !!innerAddon
      });

      var controlGroupClassName = (0, _classnames2.default)('ui-form-control-group', {
        'ui-form-control-group-with-suffix': !!suffix,
        'ui-form-control-group-with-prefix': !!prefix
      });

      if (this.isCheckboxDefault()) {
        var classNameCheckbox = (0, _classnames2.default)('ui-form-item-checkbox-default', { 'ui-form-input-checkbox-default-right': right });
        return _react2.default.createElement(
          'div',
          { className: classNameCheckbox },
          this.renderControl()
        );
      } else {
        return _react2.default.createElement(
          'div',
          { className: className },
          _react2.default.createElement(
            'div',
            { className: controlGroupWrapperClassName },
            _react2.default.createElement(
              'div',
              { className: controlGroupClassName },
              prefix && _react2.default.createElement(
                'div',
                { className: prefixClassName },
                prefix
              ),
              _react2.default.createElement(
                'div',
                { className: "ui-form-control-wrapper " },
                this.renderControl(),
                spinner && _react2.default.createElement(
                  'div',
                  { className: 'ui-form-control-spinner' },
                  _react2.default.createElement(_Spinner.Spinner, null)
                )
              ),
              suffix && _react2.default.createElement(
                'div',
                { className: suffixClassName },
                suffix
              )
            ),
            dropdown,
            innerAddon && _react2.default.createElement(
              'div',
              { className: 'ui-form-control-group-addon' },
              innerAddon
            )
          ),
          this.renderErrors(),
          description && _react2.default.createElement(
            'div',
            { className: 'ui-form-input-description' },
            description
          ),
          addon && _react2.default.createElement(
            'div',
            { className: 'ui-form-input-addon' },
            addon
          )
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props10 = this.props,
          compact = _props10.compact,
          type = _props10.type,
          inline = _props10.inline,
          right = _props10.right;


      var className = (0, _classnames2.default)('ui-form-item', 'ui-form-item-type-' + (type || 'custom'), {
        'ui-form-item-compact': !this.isCheckboxDefault() && compact,
        'ui-form-item-inline': !this.isCheckboxDefault() && inline
      });

      if (this.isCheckboxDefault()) {
        return _react2.default.createElement(
          'div',
          { className: className },
          !right && this.renderInput(),
          this.renderLabel(),
          right && this.renderInput()
        );
      } else {
        return _react2.default.createElement(
          'div',
          { className: className },
          this.renderLabel(),
          this.renderInput()
        );
      }
    }
  }]);

  return FormItem;
}(_react.Component);

FormItem.propTypes = {
  addon: _react2.default.PropTypes.node,
  children: _react2.default.PropTypes.node,
  compact: _react2.default.PropTypes.bool,
  defaultValue: _react2.default.PropTypes.any,
  description: _react2.default.PropTypes.node,
  disabled: _react2.default.PropTypes.bool,
  dropdown: _react2.default.PropTypes.node,
  element: _react2.default.PropTypes.object,
  errors: _react2.default.PropTypes.array.isRequired,
  guard: _react2.default.PropTypes.string,
  innerAddon: _react2.default.PropTypes.node,
  label: _react2.default.PropTypes.string,
  labelAddon: _react2.default.PropTypes.object,
  onChange: _react2.default.PropTypes.func,
  options: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.shape({
    label: _react2.default.PropTypes.string.isRequired,
    value: _react2.default.PropTypes.string,
    disabled: _react2.default.PropTypes.bool
  })),
  placeholder: _react2.default.PropTypes.string,
  prefix: _react2.default.PropTypes.node,
  pristine: _react2.default.PropTypes.bool,
  required: _react2.default.PropTypes.bool,
  requiredText: _react2.default.PropTypes.string.isRequired,
  suffix: _react2.default.PropTypes.any,
  tabIndex: _react2.default.PropTypes.number,
  type: _react2.default.PropTypes.string,
  value: _react2.default.PropTypes.any,

  // If true, the error message will be hidden
  hideErrorMessage: _react2.default.PropTypes.bool,

  // Whether the form should be rendered inline
  inline: _react2.default.PropTypes.bool,

  // Specifies whether a spinner should be rendered
  spinner: _react2.default.PropTypes.bool,

  // A ref which is applied to the specific control element (e.g for focus)
  controlRef: _react2.default.PropTypes.func,

  hide: _react2.default.PropTypes.bool,

  width: _react2.default.PropTypes.oneOf(['short', 'normal', 'full']),

  labelNote: _react2.default.PropTypes.string,

  allowShowZero: _react2.default.PropTypes.bool,

  right: _react2.default.PropTypes.bool,

  bold: _react2.default.PropTypes.bool
};

FormItem.defaultProps = {
  children: null,
  controlRef: function controlRef() {},
  disabled: false,
  errors: [],
  onChange: function onChange() {},
  options: [],
  requiredText: '*',
  hide: false,
  width: 'full',
  allowShowZero: false,
  right: false,
  bold: false
};

exports.default = FormItem;