'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _List = require('../List');

var _FormOptionListItem = require('./FormOptionListItem');

var _FormOptionListItem2 = _interopRequireDefault(_FormOptionListItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function filterListItems(item) {
  return item.type && item.type === _FormOptionListItem2.default;
}

function FormOptionList(props) {
  var children = props.children,
      name = props.name,
      onChange = props.onChange,
      value = props.value,
      multiple = props.multiple,
      title = props.title,
      embedded = props.embedded,
      omitOnClick = props.omitOnClick,
      inline = props.inline,
      className = props.className;


  var itemOnChange = function itemOnChange(data) {
    if (multiple) {
      onChange(_extends({}, value, data));
    } else {
      onChange(data);
    }
  };

  return _react2.default.createElement(
    _List.List,
    { title: title, embedded: embedded, inline: inline, className: className },
    [].concat(children).filter(filterListItems).map(function (child, index) {
      var defaultChecked = multiple ? (0, _lodash.get)(value, child.props.value) === true : child.props.value === value;

      var newProps = _extends({}, child.props, {
        name: name,
        key: index,
        defaultChecked: defaultChecked,
        checkbox: multiple,
        onChange: itemOnChange,
        omitOnClick: omitOnClick
      });

      return _react2.default.createElement(_FormOptionListItem2.default, newProps);
    })
  );
}

FormOptionList.propTypes = {
  children: _react2.default.PropTypes.node,
  name: _react2.default.PropTypes.string,
  title: _react2.default.PropTypes.string,
  onChange: _react2.default.PropTypes.func.isRequired,
  value: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.object]),
  multiple: _react2.default.PropTypes.bool,
  embedded: _react2.default.PropTypes.bool,
  omitOnClick: _react2.default.PropTypes.bool,
  inline: _react2.default.PropTypes.bool,
  className: _react2.default.PropTypes.string
};

exports.default = FormOptionList;