'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _List = require('../List');

var _Flex = require('../Flex');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function FormOptionListItem(props) {
  var children = props.children,
      value = props.value,
      onChange = props.onChange,
      defaultChecked = props.defaultChecked,
      checkbox = props.checkbox,
      name = props.name,
      omitOnClick = props.omitOnClick;


  var onSelect = function onSelect() {
    if (checkbox) {
      // Invert the current value
      onChange(_defineProperty({}, value, !defaultChecked));
    } else {
      onChange(value);
    }
  };

  var onClick = omitOnClick ? null : onSelect;

  var wrappedOnChange = function wrappedOnChange(event) {
    if (checkbox) {
      onChange(_defineProperty({}, value, event.target.checked));
    } else {
      onChange(value);
    }
  };

  function renderInput() {
    if (checkbox) {
      return _react2.default.createElement('input', {
        type: 'checkbox',
        onChange: wrappedOnChange,
        value: value,
        checked: defaultChecked
      });
    }

    return _react2.default.createElement('input', {
      type: 'radio',
      value: value,
      name: name,
      onChange: wrappedOnChange,
      checked: defaultChecked
    });
  }

  return _react2.default.createElement(
    _List.ListItem,
    { onClick: onClick },
    _react2.default.createElement(
      _Flex.Flex,
      { noPadding: true, noWrap: true },
      _react2.default.createElement(
        _Flex.FlexItem,
        { width: 40, noShrink: true },
        renderInput()
      ),
      _react2.default.createElement(
        _Flex.FlexItem,
        { grow: true },
        children
      )
    )
  );
}

FormOptionListItem.propTypes = {
  children: _react2.default.PropTypes.node,
  value: _react2.default.PropTypes.any.isRequired,
  name: _react2.default.PropTypes.string,
  onChange: _react2.default.PropTypes.func,
  defaultChecked: _react2.default.PropTypes.bool.isRequired,
  checkbox: _react2.default.PropTypes.bool,
  omitOnClick: _react2.default.PropTypes.bool
};

FormOptionListItem.defaultProps = {
  defaultChecked: false
};

exports.default = FormOptionListItem;