'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function FunnelStep(_ref) {
  var done = _ref.done,
      label = _ref.label,
      number = _ref.number,
      onClick = _ref.onClick;

  var className = (0, _classnames2.default)('ui-funnel-step', {
    'ui-funnel-step-done': done
  });

  var renderLabel = function renderLabel() {
    return label && _react2.default.createElement(
      'div',
      { className: 'ui-funnel-step-label' },
      label
    );
  };
  var renderNumber = function renderNumber() {
    if (done) {
      return _react2.default.createElement(
        'div',
        { className: 'ui-funnel-step-icon' },
        _react2.default.createElement(_Icon.Icon, { name: 'check' })
      );
    }

    return _react2.default.createElement(
      'div',
      { className: 'ui-funnel-step-number' },
      number
    );
  };

  return _react2.default.createElement(
    'div',
    { className: className, onClick: onClick },
    renderNumber(),
    renderLabel()
  );
}

FunnelStep.propTypes = {
  label: _react2.default.PropTypes.string,
  number: _react2.default.PropTypes.number.isRequired,
  done: _react2.default.PropTypes.bool,
  onClick: _react2.default.PropTypes.func
};

FunnelStep.defaultProps = {
  label: null,
  onClick: null,
  done: false
};

exports.default = FunnelStep;