'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Progress = require('../Progress');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Gallery = function Gallery(props) {
  var children = props.children,
      progress = props.progress,
      headerContent = props.header;


  var progressBar = progress ? _react2.default.createElement(
    'div',
    { className: 'ui-gallery-progress' },
    _react2.default.createElement(_Progress.Progress, { progress: progress })
  ) : null;
  var header = headerContent ? _react2.default.createElement(
    'div',
    { className: 'ui-gallery-header' },
    headerContent
  ) : null;

  return _react2.default.createElement(
    'div',
    { className: (0, _classnames2.default)('ui-gallery') },
    header,
    progressBar,
    children
  );
};

Gallery.propTypes = {
  children: _react2.default.PropTypes.node,

  // If specified, displayed in the gallery header
  header: _react2.default.PropTypes.node,

  // If a progress is given, a progress bar component will be rendered
  // on top of the gallery (useful for uploader scenarios).
  progress: _react2.default.PropTypes.number
};

Gallery.defaultProps = {};

exports.default = Gallery;