'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

// Utils


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GridCol = function GridCol(props) {
  var classes = [];
  var center = props.center,
      right = props.right,
      left = props.left,
      flex = props.flex,
      marginAuto = props.marginAuto,
      bottom = props.bottom;


  if (props.borders) {
    if (props.borders.match(/l/)) {
      classes.push('ui-grid-col-border-left');
    }
    if (props.borders.match(/r/)) {
      classes.push('ui-grid-col-border-right');
    }
  }

  if (typeof props.width === 'number') {
    classes.push('col-md-' + props.width);
  } else if (_typeof(props.width) === 'object') {
    Object.keys(props.width).forEach(function (key) {
      classes.push('col-' + key + '-' + props.width[key]);
    });
  }

  if (typeof props.offset === 'number') {
    classes.push('col-md-offset-' + props.offset);
  } else if (_typeof(props.offset) === 'object') {
    Object.keys(props.offset).forEach(function (key) {
      classes.push('col-' + key + '-offset-' + props.offset[key]);
    });
  }

  if (center) {
    classes.push('col-align-center');
  }

  if (right) {
    classes.push('col-align-right');
  }

  if (left) {
    classes.push('col-align-left');
  }

  if (flex) {
    classes.push('ui-flex-gird');
  }

  if (marginAuto) {
    classes.push('ui-margin-auto-gird');
  }

  if (bottom) {
    classes.push('ui-flex-end-gird');
  }

  return _react2.default.createElement(
    'div',
    { className: (0, _classnames2.default)(classes) },
    props.children
  );
};

GridCol.propTypes = {
  // width and offset can either be passed in as number, e.g.
  // width={4} or as object with device identifiers as keys, e.g.
  // width={{ md: 4, sm: 12 }}.
  width: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.object]).isRequired,
  offset: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.object]),
  children: _react2.default.PropTypes.node,
  borders: _react2.default.PropTypes.string,

  /**
   * Centers the content
   * @type {Boolean}
   */
  center: _react2.default.PropTypes.bool,
  left: _react2.default.PropTypes.bool,
  right: _react2.default.PropTypes.bool,
  flex: _react2.default.PropTypes.bool,
  marginAuto: _react2.default.PropTypes.bool,
  bottom: _react2.default.PropTypes.bool
};

GridCol.defaultProps = {
  width: 12
};

exports.default = GridCol;