'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Headline = require('../Headline');

var _Spacing = require('../Spacing');

var _Button = require('../Button');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Guide = function Guide(props) {
  var sections = props.children;
  var title = props.title;
  var description = props.description;
  var ankerName = props.ankerName;
  var topAnkerName = props.topAnkerName;

  return _react2.default.createElement(
    'div',
    { className: 'ui-guide' },
    _react2.default.createElement('div', { name: ankerName }),
    _react2.default.createElement(
      _Spacing.Spacing,
      { margin: '2xb' },
      _react2.default.createElement(
        'div',
        { className: 'ui-guide-title' },
        _react2.default.createElement(
          _Headline.Headline,
          null,
          title
        ),
        topAnkerName ? _react2.default.createElement(
          _Button.Button,
          {
            onClick: function onClick() {
              window.location.href = '#' + topAnkerName;
            },
            small: true
          },
          'Scroll up'
        ) : null
      )
    ),
    _react2.default.createElement(
      _Spacing.Spacing,
      { margin: '2xb' },
      _react2.default.createElement(
        'div',
        { className: 'ui-guide-description' },
        description
      )
    ),
    _react2.default.createElement(
      'div',
      { className: 'ui-guide-sections' },
      sections
    )
  );
};

Guide.propTypes = {
  title: _react2.default.PropTypes.string.isRequired,
  description: _react2.default.PropTypes.string,
  ankerName: _react2.default.PropTypes.string.isRequired,
  topAnkerName: _react2.default.PropTypes.string,
  children: _react2.default.PropTypes.node
};

exports.default = Guide;