'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Headline = require('../Headline');

var _Box = require('../Box');

var _Spacing = require('../Spacing');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // React


// Utils


// Framework components


var GuideSection = function (_Component) {
  _inherits(GuideSection, _Component);

  function GuideSection() {
    _classCallCheck(this, GuideSection);

    var _this = _possibleConstructorReturn(this, (GuideSection.__proto__ || Object.getPrototypeOf(GuideSection)).call(this));

    _this.state = {
      markupShown: false
    };
    return _this;
  }

  _createClass(GuideSection, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var title = this.props.title;
      var description = this.props.description;
      var markup = this.props.markup;
      var code = this.props.code;

      return _react2.default.createElement(
        'div',
        { className: 'ui-guide-section' },
        _react2.default.createElement(
          _Spacing.Spacing,
          { margin: '2xb' },
          _react2.default.createElement(
            'div',
            { className: 'ui-guide-section-title' },
            _react2.default.createElement(
              _Headline.Headline,
              { size: 'medium' },
              title
            )
          )
        ),
        _react2.default.createElement(
          _Spacing.Spacing,
          { margin: '2xb' },
          _react2.default.createElement(
            'div',
            { className: 'ui-guide-section-description' },
            description
          )
        ),
        _react2.default.createElement(
          _Box.Box,
          { margin: '2xb' },
          _react2.default.createElement(
            _Box.BoxHeader,
            null,
            'Preview'
          ),
          _react2.default.createElement(
            _Box.BoxContent,
            null,
            markup
          ),
          _react2.default.createElement(
            _Box.BoxHeader,
            null,
            _react2.default.createElement(
              'a',
              {
                onClick: function onClick() {
                  _this2.setState({ markupShown: !_this2.state.markupShown });
                }
              },
              'Markup'
            )
          ),
          _react2.default.createElement(
            'div',
            {
              className: (0, _classnames2.default)('ui-guide-section-code', {
                'ui-guide-section-markup-shown': this.state.markupShown
              })
            },
            _react2.default.createElement(
              'pre',
              null,
              code
            )
          )
        )
      );
    }
  }]);

  return GuideSection;
}(_react.Component);

GuideSection.propTypes = {
  title: _react2.default.PropTypes.string.isRequired,
  description: _react2.default.PropTypes.string,
  markup: _react2.default.PropTypes.object.isRequired,
  code: _react2.default.PropTypes.string.isRequired
};

exports.default = GuideSection;