'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _decorators = require('../../decorators');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Headline(_ref) {
  var children = _ref.children,
      center = _ref.center,
      right = _ref.right,
      size = _ref.size;

  var className = (0, _classnames2.default)('ui-headline', 'ui-headline-size-' + size, {
    'ui-align-center': center,
    'ui-align-right': right
  });
  return _react2.default.createElement(
    'div',
    { className: className },
    children
  );
}

Headline.propTypes = {
  size: _react2.default.PropTypes.string.isRequired,
  children: _react2.default.PropTypes.node,
  center: _react2.default.PropTypes.bool,
  right: _react2.default.PropTypes.bool
};

Headline.defaultProps = {
  size: 'default'
};

exports.default = (0, _decorators.spaceable)((0, _decorators.muteable)(Headline));