'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../Icon');

var _hocs = require('../../hocs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function HeroUnit(props) {
  var children = props.children,
      icon = props.icon,
      iconTheme = props.iconTheme,
      style = props.style,
      title = props.title;


  return _react2.default.createElement(
    'div',
    { className: 'ui-hero-unit', style: style },
    _react2.default.createElement(
      'div',
      { className: 'ui-hero-unit-header' },
      icon && _react2.default.createElement(
        'div',
        { className: 'ui-hero-unit-icon' },
        _react2.default.createElement(_Icon.Icon, { name: icon, theme: iconTheme })
      ),
      _react2.default.createElement(
        'div',
        { className: 'ui-hero-unit-title' },
        title
      )
    ),
    _react2.default.createElement(
      'div',
      { className: 'ui-hero-unit-content' },
      children
    )
  );
}

HeroUnit.propTypes = {
  children: _react2.default.PropTypes.node,
  icon: _react2.default.PropTypes.string,
  iconTheme: _react2.default.PropTypes.string,
  style: _react2.default.PropTypes.object,
  title: _react2.default.PropTypes.string.isRequired
};

HeroUnit.defaultProps = {
  children: null,
  icon: null,
  iconTheme: null,
  style: null
};

exports.default = (0, _hocs.spacable)(HeroUnit);