'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../Icon');

var _Badge = require('../Badge');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Hint = function Hint(_ref) {
  var children = _ref.children,
      label = _ref.label,
      icon = _ref.icon;
  return _react2.default.createElement(
    'div',
    { className: 'ui-hint' },
    _react2.default.createElement(
      'div',
      { className: 'ui-hint-label' },
      _react2.default.createElement(
        _Badge.Badge,
        { theme: 'success' },
        icon && _react2.default.createElement(_Icon.Icon, { name: icon }),
        ' ',
        label
      )
    ),
    _react2.default.createElement(
      'div',
      { className: 'ui-hint-content' },
      children
    )
  );
};

Hint.propTypes = {
  children: _react2.default.PropTypes.node,
  label: _react2.default.PropTypes.string.isRequired,
  icon: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.bool])
};

Hint.defaultProps = {
  icon: 'lightbulb-o'
};

exports.default = Hint;