'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function InlineList(_ref) {
  var block = _ref.block,
      children = _ref.children,
      center = _ref.center;

  var className = (0, _classnames2.default)('ui-inline-list', {
    'ui-inline-list-block': block,
    'ui-inline-list-center': center
  });

  return _react2.default.createElement(
    'div',
    { className: className },
    [].concat(children).map(function (child, index) {
      return _react2.default.createElement(
        'div',
        { className: 'ui-inline-list-item', key: index },
        child
      );
    })
  );
}

InlineList.propTypes = {
  children: _react2.default.PropTypes.node,
  block: _react2.default.PropTypes.bool,
  center: _react2.default.PropTypes.bool
};

InlineList.defaulProps = {
  block: false,
  center: false
};

exports.default = InlineList;