'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _KpiHorizon = require('./KpiHorizon');

var _KpiHorizon2 = _interopRequireDefault(_KpiHorizon);

var _Spinner = require('../Spinner');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Kpi(_ref) {
  var value = _ref.value,
      label = _ref.label,
      horizons = _ref.horizons,
      loading = _ref.loading,
      noMargin = _ref.noMargin;

  return _react2.default.createElement(
    'div',
    { className: (0, _classnames2.default)('ui-kpi', { 'ui-kpi-no-margin': noMargin }) },
    _react2.default.createElement(
      'div',
      { className: 'ui-kpi-primary' },
      _react2.default.createElement(
        'div',
        { className: 'ui-kpi-value' },
        loading ? _react2.default.createElement(_Spinner.Spinner, null) : value
      ),
      label && _react2.default.createElement(
        'div',
        { className: 'ui-kpi-description' },
        label
      )
    ),
    horizons.length > 0 && _react2.default.createElement(
      'div',
      { className: 'ui-kpi-horizons' },
      horizons.map(function (horizon, index) {
        return _react2.default.createElement(_KpiHorizon2.default, {
          key: index,
          value: horizon.value,
          label: horizon.label,
          loading: loading
        });
      })
    )
  );
}

Kpi.propTypes = {
  value: _react2.default.PropTypes.node,
  label: _react2.default.PropTypes.string,
  loading: _react2.default.PropTypes.bool,
  noMargin: _react2.default.PropTypes.bool,
  horizons: _react2.default.PropTypes.array
};

Kpi.defaultProps = {
  horizons: []
};

exports.default = Kpi;