'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function List(_ref) {
  var children = _ref.children,
      title = _ref.title,
      embedded = _ref.embedded,
      inline = _ref.inline,
      className = _ref.className;

  return _react2.default.createElement(
    'div',
    { className: (0, _classnames2.default)('ui-list', { 'ui-list-embedded': embedded }, className) },
    title && _react2.default.createElement(
      'div',
      { className: 'ui-list-title' },
      title
    ),
    _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('ui-list-children', { 'ui-inline-list': inline }) },
      children
    )
  );
}

List.propTypes = {
  children: _react2.default.PropTypes.node,
  title: _react2.default.PropTypes.string,
  embedded: _react2.default.PropTypes.bool,
  inline: _react2.default.PropTypes.bool,
  className: _react2.default.PropTypes.string
};

exports.default = List;