'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../Spacing/utils');

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Message(_ref) {
  var theme = _ref.theme,
      children = _ref.children,
      icon = _ref.icon,
      margin = _ref.margin;

  var style = (0, _utils.spacingStyles)({ margin: margin });

  var className = (0, _classnames2.default)('ui-message', 'ui-message-theme-' + theme);

  return _react2.default.createElement(
    'div',
    { style: style, className: className },
    icon && _react2.default.createElement(
      'div',
      { className: 'ui-message-icon' },
      _react2.default.createElement(_Icon.Icon, { name: icon })
    ),
    _react2.default.createElement(
      'div',
      { className: 'ui-message-content' },
      children
    )
  );
}

Message.propTypes = {
  icon: _react2.default.PropTypes.string,
  margin: _react2.default.PropTypes.string,
  children: _react2.default.PropTypes.node,
  theme: _react2.default.PropTypes.oneOf(['default', 'success', 'error']).isRequired
};

Message.defaultProps = {
  theme: 'default'
};

exports.default = Message;