'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = function (_Component) {
  _inherits(Modal, _Component);

  /**
   * Prop types
   * @type {Object}
   */
  function Modal(props) {
    _classCallCheck(this, Modal);

    /**
     * Holds a reference to the modal dom element
     * @type {Object}
     */
    var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

    _this.setModalRef = function (element) {
      if (element) {
        _this.modal = element;
      }
    };

    _this.handleDocumentClick = function (event) {
      var _this$props = _this.props,
          closable = _this$props.closable,
          onClose = _this$props.onClose;

      // Only trigger onClose when the modal is closable and the click is not performed
      // somewhere inside the modal

      if (closable && !_this.modal.contains(event.target) && _this.state.open) {
        _this.setState({ open: false });
        onClose();
      }
    };

    _this.modal = null;

    _this.state = {
      open: props.open
    };
    return _this;
  }

  /**
   * Default props
   * @type {Object}
   */


  _createClass(Modal, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var open = this.state.open;


      document.addEventListener('click', this.handleDocumentClick, true);

      this.setBodyClass(open);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var open = _ref.open;

      this.setState({ open: open });
      this.setBodyClass(open);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.handleDocumentClick, true);
      this.removeBodyClass();
    }
  }, {
    key: 'setBodyClass',
    value: function setBodyClass(isOpen) {
      if (isOpen) {
        this.addBodyClass();
      } else {
        this.removeBodyClass();
      }
    }
  }, {
    key: 'addBodyClass',
    value: function addBodyClass() {
      document.getElementsByTagName('body')[0].classList.add(Modal.bodyClassName);
    }
  }, {
    key: 'removeBodyClass',
    value: function removeBodyClass() {
      document.getElementsByTagName('body')[0].classList.remove(Modal.bodyClassName);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          size = _props.size;
      var open = this.state.open;


      var wrapperClassName = (0, _classnames2.default)('ui-modal-wrapper', {
        'ui-modal-open': open
      });
      var modalClassName = (0, _classnames2.default)('ui-modal', 'ui-modal-size-' + size);

      return _react2.default.createElement(
        'div',
        { className: wrapperClassName },
        _react2.default.createElement('div', { className: (0, _classnames2.default)('ui-modal-backdrop') }),
        _react2.default.createElement(
          'div',
          { ref: this.setModalRef, className: modalClassName },
          children
        )
      );
    }
  }]);

  return Modal;
}(_react.Component);

Modal.bodyClassName = 'ui-modal-attached';
Modal.propTypes = {
  children: _react2.default.PropTypes.node,
  // If set to true, a click on the backdrop will not trigger onClose
  closable: _react2.default.PropTypes.bool,

  // Triggered on close
  onClose: _react2.default.PropTypes.func,

  // Defines the current open state
  open: _react2.default.PropTypes.bool,

  // Defines the possible sizes - will be translated to css classes
  size: _react2.default.PropTypes.oneOf(['default', 'large', 'larger', 'small']).isRequired
};
Modal.defaultProps = {
  closable: true,
  size: 'default'
};
exports.default = Modal;