'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Nav(_ref) {
  var inverse = _ref.inverse,
      children = _ref.children,
      fixed = _ref.fixed,
      prefix = _ref.prefix;

  var className = (0, _classnames2.default)('ui-nav', {
    'ui-nav-fixed': fixed,
    'ui-nav-inverse': inverse
  });

  return _react2.default.createElement(
    'div',
    { className: className },
    prefix && _react2.default.createElement(
      'div',
      { className: 'ui-nav-prefix' },
      prefix
    ),
    _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('ui-nav-navitems') },
      children
    )
  );
}

Nav.propTypes = {
  fixed: _react2.default.PropTypes.bool.isRequired,
  inverse: _react2.default.PropTypes.bool.isRequired,
  children: _react2.default.PropTypes.node,
  prefix: _react2.default.PropTypes.node
};

Nav.defaultProps = {
  fixed: false,
  inverse: false,
  prefix: null,
  children: null
};

exports.default = Nav;