'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _times = require('lodash/times');

var _times2 = _interopRequireDefault(_times);

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Utils


// Framework components


var Pagination = function (_Component) {
  _inherits(Pagination, _Component);

  function Pagination() {
    _classCallCheck(this, Pagination);

    return _possibleConstructorReturn(this, (Pagination.__proto__ || Object.getPrototypeOf(Pagination)).apply(this, arguments));
  }

  _createClass(Pagination, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({
        group: 0
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var divisionResult = nextProps.current / this.props.collapseThreshold;
      var currentGroupIndex = divisionResult % 1 === 0 ? (0, _lodash.parseInt)(divisionResult - 1) : (0, _lodash.parseInt)((0, _lodash.floor)(divisionResult));
      this.setState({
        group: currentGroupIndex
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var collapseThreshold = (0, _lodash.parseInt)(this.props.collapseThreshold);
      var count = (0, _lodash.parseInt)(this.props.count || 0);
      var groups = [];
      var groupsCount = (0, _lodash.parseInt)(Math.ceil(count / collapseThreshold));
      var current = (0, _lodash.parseInt)(this.props.current);
      var _onClick = function _onClick(page) {
        if (page !== current && page >= 1 && page <= count) {
          _this2.props.onClick(page);
        }
      };
      var label = this.props.label ? _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-pagination-info') },
        this.props.label
      ) : null;

      var previous = _react2.default.createElement(
        'div',
        { className: 'ui-pagination-control-previous' },
        _react2.default.createElement(
          'a',
          { onClick: function onClick() {
              return _onClick(current - 1);
            } },
          _react2.default.createElement(_Icon.Icon, { name: 'caret-left' })
        )
      );

      var next = _react2.default.createElement(
        'div',
        { className: 'ui-pagination-control-next' },
        _react2.default.createElement(
          'a',
          { onClick: function onClick() {
              return _onClick(current + 1);
            } },
          _react2.default.createElement(_Icon.Icon, { name: 'caret-right' })
        )
      );

      var changeGroup = function changeGroup(group) {
        _this2.setState({
          group: group < 0 ? 0 : Math.min(group, groupsCount - 1)
        });
      };

      var previousGroup = groupsCount > 1 && this.state.group > 0 ? _react2.default.createElement(
        'div',
        { className: 'ui-pagination-control-previous-group' },
        _react2.default.createElement(
          'a',
          { onClick: function onClick() {
              return changeGroup(_this2.state.group - 1);
            } },
          '...'
        )
      ) : null;

      var nextGroup = groupsCount > 1 && this.state.group < groupsCount - 1 ? _react2.default.createElement(
        'div',
        { className: 'ui-pagination-control-next-group' },
        _react2.default.createElement(
          'a',
          { onClick: function onClick() {
              return changeGroup(_this2.state.group + 1);
            } },
          '...'
        )
      ) : null;

      var pages = [];
      var index = 0;

      (0, _times2.default)(count, function () {
        var page = index + 1;
        pages.push(_react2.default.createElement(
          'div',
          {
            key: index,
            className: (0, _classnames2.default)('ui-pagination-page', {
              'ui-pagination-page-active': page === current
            })
          },
          _react2.default.createElement(
            'a',
            { onClick: function onClick() {
                return _onClick(page);
              } },
            page
          )
        ));
        index += 1;
      });

      (0, _times2.default)(groupsCount, function (i) {
        var fromIndex = i * collapseThreshold;
        var toIndex = Math.min(i * collapseThreshold + collapseThreshold, count);
        groups.push(_react2.default.createElement(
          'div',
          {
            key: i,
            className: (0, _classnames2.default)('ui-pagination-pagegroup', {
              'ui-pagination-pagegroup-current': _this2.state.group === i
            })
          },
          pages.slice(fromIndex, toIndex)
        ));
      });

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('ui-pagination', {
            'ui-pagination-disabled': this.props.disabled
          })
        },
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-pagination-pages') },
          previous,
          previousGroup,
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)('ui-pagination-pagegroups') },
            groups
          ),
          nextGroup,
          next
        ),
        label
      );
    }
  }]);

  return Pagination;
}(_react.Component);

Pagination.propTypes = {
  label: _react2.default.PropTypes.string,
  count: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string]),
  current: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string]),
  onClick: _react2.default.PropTypes.func,
  disabled: _react2.default.PropTypes.bool,
  collapseThreshold: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string])
};

Pagination.defaultProps = {
  current: 1,
  collapseThreshold: 10
};

exports.default = Pagination;