'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Progress = function Progress(props) {
  var progress = props.progress,
      showValue = props.showValue,
      small = props.small;


  var percentValue = progress + '%';
  var className = (0, _classnames2.default)('ui-progress', { 'ui-progress-small': small });
  var value = showValue ? _react2.default.createElement(
    'div',
    { className: 'ui-progress-value' },
    percentValue
  ) : null;

  return _react2.default.createElement(
    'div',
    { className: className },
    _react2.default.createElement('div', { className: 'ui-progress-bar', style: { width: percentValue } }),
    value
  );
};

Progress.propTypes = {
  // The progress bar progress (e.g. 98.5)
  progress: _react2.default.PropTypes.number.isRequired,

  // The bar can appear smaller
  small: _react2.default.PropTypes.bool,

  // Specifies whether the progress value should be displayed
  showValue: _react2.default.PropTypes.bool
};

Progress.defaultProps = {
  showValue: true
};

exports.default = Progress;