'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ResourceLink(_ref) {
  var href = _ref.href,
      children = _ref.children,
      icon = _ref.icon,
      target = _ref.target;

  var rel = target === 'blank' ? 'noopener noreferrer' : null;

  return _react2.default.createElement(
    'a',
    { className: 'ui-resource-link', href: href, target: target, rel: rel },
    _react2.default.createElement(_Icon.Icon, { name: icon }),
    children
  );
}

ResourceLink.propTypes = {
  children: _react2.default.PropTypes.any,
  icon: _react2.default.PropTypes.string,
  href: _react2.default.PropTypes.string.isRequired,
  target: _react2.default.PropTypes.string.isRequired
};

ResourceLink.defaultProps = {
  icon: 'external-link-square',
  target: '_blank'
};

exports.default = ResourceLink;