'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../Spacing/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ResourceList(_ref) {
  var children = _ref.children,
      title = _ref.title,
      margin = _ref.margin;

  var style = (0, _utils.spacingStyles)({ margin: margin });

  return _react2.default.createElement(
    'div',
    { className: 'ui-resource-list', style: style },
    title && _react2.default.createElement(
      'div',
      { className: 'ui-resource-list-title' },
      title
    ),
    _react2.default.createElement(
      'div',
      { className: 'ui-resource-list-items' },
      children
    )
  );
}

ResourceList.propTypes = {
  children: _react2.default.PropTypes.any,
  title: _react2.default.PropTypes.string,
  margin: _react2.default.PropTypes.string
};

exports.default = ResourceList;