'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Sidebar = function (_React$Component) {
  _inherits(Sidebar, _React$Component);

  function Sidebar(props) {
    _classCallCheck(this, Sidebar);

    var _this = _possibleConstructorReturn(this, (Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call(this, props));

    _this.onExpandClick = function () {
      _this.setState(function (state) {
        return { expanded: !state.expanded };
      });
    };

    _this.state = {
      // This is just for responsive mode and used by CSS. Has no direct
      // effect on the UI
      expanded: false
    };
    return _this;
  }

  _createClass(Sidebar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          embedded = _props.embedded,
          expandLabel = _props.expandLabel;
      var expanded = this.state.expanded;


      var className = (0, _classnames2.default)('ui-sidebar', {
        'ui-sidebar-embedded': embedded,
        'ui-sidebar-expanded': expanded
      });

      return _react2.default.createElement(
        'div',
        { className: className },
        expandLabel && _react2.default.createElement(
          'div',
          { className: 'ui-sidebar-expand-wrapper' },
          _react2.default.createElement(
            'button',
            { onClick: this.onExpandClick },
            _react2.default.createElement(_Icon.Icon, { name: 'bars' }),
            expandLabel
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-sidebar-items' },
          children
        )
      );
    }
  }]);

  return Sidebar;
}(_react2.default.Component);

Sidebar.propTypes = {
  children: _react2.default.PropTypes.node,
  embedded: _react2.default.PropTypes.bool,
  expandLabel: _react2.default.PropTypes.string
};
Sidebar.defaultProps = {
  children: null,
  embedded: false,
  expandLabel: null
};
exports.default = Sidebar;