'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _alignable = require('../../decorators/alignable');

var _alignable2 = _interopRequireDefault(_alignable);

var _utils = require('../../utils');

var _utils2 = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Spacing = function Spacing(props) {
  var children = props.children;
  var margin = props.margin;
  var padding = props.padding;
  var marginAuto = props.marginAuto;
  var styles = {};

  if (margin) {
    styles = (0, _utils.merge)(styles, (0, _utils2.spacingStyles)({ margin: margin }));
  }

  if (padding) {
    styles = (0, _utils.merge)(styles, (0, _utils2.spacingStyles)({ padding: padding }));
  }

  return _react2.default.createElement(
    'div',
    {
      style: styles,
      className: (0, _classnames2.default)({
        'ui-helpers-flexbox': props.flexbox,
        'ui-margin-auto-gird': props.marginAuto
      })
    },
    children
  );
};

var validator = function validator(props, pn, cname) {
  if (props[pn] && !/[0-9.]+x(t|l|r|b|v|h)?/.test(props[pn])) {
    return new Error('Prop ' + pn + ' in ' + cname + ' invalid. Validation of ' + props[pn] + ' failed.');
  }
  return null;
};

Spacing.propTypes = {
  padding: validator,
  margin: validator,
  children: _react2.default.PropTypes.node,
  flexbox: _react2.default.PropTypes.bool,
  marginAuto: _react2.default.PropTypes.bool
};

exports.default = (0, _alignable2.default)(Spacing);