'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.spacingStyles = undefined;

var _lodash = require('lodash');

// eslint-disable-next-line import/prefer-default-export
var spacingStyles = exports.spacingStyles = function spacingStyles(definitions) {
  var styles = {};
  Object.keys(definitions).forEach(function (type) {
    var definition = definitions[type];
    if ((0, _lodash.isString)(definition)) {
      var lastChar = definition.substr(definition.length - 1, definition.length);
      var match = definition.match(/[0-9.]{1,4}/);
      if ((0, _lodash.isArray)(match)) {
        var size = (0, _lodash.parseInt)(parseFloat(match[0]) * 10);
        var px = size + 'px';
        var mapping = {
          x: px,
          b: '0 0 ' + px + ' 0',
          r: '0 ' + px + ' 0 0',
          l: '0 0 0 ' + px,
          t: px + ' 0 0 0',
          v: px + ' 0',
          h: '0 ' + px
        };
        var mapped = mapping[lastChar];
        styles[type] = mapped;
      }
    }
  });
  return styles;
};