'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Spinner(_ref) {
  var large = _ref.large,
      muted = _ref.muted;

  if (large) {
    return _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('ui-spinner', 'ui-spinner-large') },
      _react2.default.createElement(
        'div',
        { className: 'spinner' },
        _react2.default.createElement('div', { className: 'bounce1' }),
        _react2.default.createElement('div', { className: 'bounce2' }),
        _react2.default.createElement('div', { className: 'bounce3' })
      )
    );
  }

  return _react2.default.createElement(
    'span',
    { className: (0, _classnames2.default)('ui-spinner') },
    _react2.default.createElement(_Icon.Icon, { name: 'circle-o-notch', spin: true, muted: muted })
  );
}

Spinner.propTypes = {
  // Renders another, larger type of spinner
  large: _react2.default.PropTypes.bool,
  muted: _react2.default.PropTypes.bool
};

exports.default = Spinner;