'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _utils = require('../../utils');

var _TableRow = require('./TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _TableColumn = require('./TableColumn');

var _TableColumn2 = _interopRequireDefault(_TableColumn);

var _Pagination = require('../Pagination');

var _Spinner = require('../Spinner');

var _Button = require('../Button');

var _Icon = require('../Icon');

var _utils2 = require('../Spacing/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.onUpdateDatum = function (prevDatum, nextDatum) {
      var onUpdate = _this.props.onUpdate;


      if (onUpdate) {
        onUpdate(prevDatum, nextDatum);
      }
    };

    _this.onExpandClick = function (datum) {
      var onExpand = _this.props.onExpand;


      var index = _this.getExpansionIndex(datum);

      if (_this.isExpanding(index)) {
        return;
      }

      if (_this.isExpanded(index)) {
        var newExpansions = _extends({}, _this.state.expansions);
        delete newExpansions[index];
        _this.setState({ expansions: newExpansions });
      } else {
        var result = onExpand(datum);

        if ((0, _utils.isPromise)(result)) {
          // Set expanding
          _this.setState(function (state) {
            return {
              expanding: state.expanding.concat(index)
            };
          });

          result.then(function (content) {
            _this.setState(function (state) {
              return {
                expanding: state.expanding.filter(function (i) {
                  return i !== index;
                }),
                expansions: _extends({}, state.expansions, _defineProperty({}, index, content))
              };
            });
          });
        }
      }
    };

    _this.onPageSizeChange = function (nextPageSize) {
      var onPageSizeChange = _this.props.onPageSizeChange;


      _this.resetExpansion();

      onPageSizeChange(nextPageSize);
    };

    _this.bodyRef = function (ref) {
      if (ref) {
        if (_this.isOrderable()) {
          // Todo - intialite drag-drop-lib on ref
        }
      }
    };

    _this.renderOrderCell = function (datum, rowIndex) {
      var data = _this.props.data;

      var lastRowIndex = data.length - 1;

      return _react2.default.createElement(
        _Button.ButtonGroup,
        null,
        _react2.default.createElement(_Button.Button, {
          icon: 'caret-up',
          disabled: rowIndex === 0,
          onClick: function onClick() {
            return _this.onMoveUpClick(datum);
          }
        }),
        _react2.default.createElement(_Button.Button, {
          icon: 'caret-down',
          disabled: rowIndex === lastRowIndex,
          onClick: function onClick() {
            return _this.onMoveDownClick(datum);
          }
        })
      );
    };

    _this.renderPagination = _this.renderPagination.bind(_this);
    _this.renderHeaderRow = _this.renderHeaderRow.bind(_this);
    _this.renderDataRows = _this.renderDataRows.bind(_this);
    _this.renderSelectColumn = _this.renderSelectColumn.bind(_this);
    _this.renderPageSizes = _this.renderPageSizes.bind(_this);
    _this.renderPrefix = _this.renderPrefix.bind(_this);
    _this.renderHeader = _this.renderHeader.bind(_this);
    _this.renderColumns = _this.renderColumns.bind(_this);

    _this.state = {
      // If the onPaginate callback returns a promise. this flag will be set to
      // true during promise fulfillment
      paginating: false,

      // Expaned rows
      expansions: {},

      // Expansion in progress
      expanding: []
    };
    return _this;
  }

  // Handles the actual selection of a row


  _createClass(Table, [{
    key: 'onSelectRow',
    value: function onSelectRow(event, datum) {
      var onSelect = this.props.onSelect;


      if (onSelect) {
        return onSelect(datum);
      }

      return null;
    }
  }, {
    key: 'onMoveUpClick',
    value: function onMoveUpClick(datum) {
      this.resetExpansion();
      this.props.onOrder(this.moveDatum(datum, -1));
    }
  }, {
    key: 'onMoveDownClick',
    value: function onMoveDownClick(datum) {
      this.resetExpansion();
      this.props.onOrder(this.moveDatum(datum, 1));
    }
  }, {
    key: 'getExpansionIndex',
    value: function getExpansionIndex(datum) {
      if (!datum.id) {
        throw new Error('For expansion, data items nedd an id field');
      }

      return datum.id;
    }
  }, {
    key: 'isSelectable',
    value: function isSelectable() {
      return typeof this.props.onSelect === 'function';
    }
  }, {
    key: 'isOrderable',
    value: function isOrderable() {
      return typeof this.props.onOrder === 'function';
    }
  }, {
    key: 'isExpanding',
    value: function isExpanding(rowIndex) {
      return this.state.expanding.indexOf(rowIndex) > -1;
    }
  }, {
    key: 'isExpanded',
    value: function isExpanded(rowIndex) {
      return this.state.expansions[rowIndex];
    }
  }, {
    key: 'isExpandable',
    value: function isExpandable() {
      return typeof this.props.onExpand === 'function';
    }
  }, {
    key: 'moveDatum',
    value: function moveDatum(datum, modifier) {
      var data = this.props.data;


      var index = data.indexOf(datum);

      return (0, _utils.move)(data, index, index + modifier);
    }
  }, {
    key: 'resetExpansion',
    value: function resetExpansion() {
      this.setState({ expansions: {}, expanding: [] });
    }
  }, {
    key: 'renderHeaderRow',
    value: function renderHeaderRow(columns) {
      return _react2.default.createElement(_TableRow2.default, {
        key: -1,
        columns: columns,
        header: true
      });
    }
  }, {
    key: 'renderEmptyBody',
    value: function renderEmptyBody() {
      var _props = this.props,
          data = _props.data,
          emptyBody = _props.emptyBody;


      if (data.length > 0) {
        return null;
      }

      return emptyBody && _react2.default.createElement(
        'div',
        { className: 'ui-table-empty' },
        emptyBody()
      );
    }
  }, {
    key: 'renderDataRows',
    value: function renderDataRows(columns) {
      var _this2 = this;

      var _props2 = this.props,
          addonBuilder = _props2.addonBuilder,
          cancelLabel = _props2.cancelLabel,
          highlighted = _props2.highlighted,
          onSelect = _props2.onSelect,
          onValidate = _props2.onValidate,
          selectOnRowClick = _props2.selectOnRowClick;


      var rows = this.props.data.map(function (datum, index) {
        var isHighlighted = highlighted ? highlighted(datum) : false;
        var addon = addonBuilder ? addonBuilder(datum) : null;
        var onRowClick = onSelect && selectOnRowClick ? function (event) {
          return _this2.onSelectRow(event, datum);
        } : null;

        var expansionIndex = _this2.isExpandable() ? _this2.getExpansionIndex(datum) : null;

        return _react2.default.createElement(_TableRow2.default, {
          addon: addon,
          cancelLabel: cancelLabel,
          columns: columns,
          datum: datum,
          expansion: _this2.state.expansions[expansionIndex],
          highlighted: isHighlighted,
          index: index,
          key: index,
          onRowClick: onRowClick,
          onUpdateDatum: _this2.onUpdateDatum,
          onValidate: onValidate
        });
      });

      // Insert custom rows if specified
      var rowsWithCustomRows = [];
      var appendCustomRow = function appendCustomRow(target, row, index) {
        [].concat(row).forEach(function (r, j) {
          return target.push(_react2.default.createElement(_TableRow2.default, _extends({
            key: index + '-' + j + '-custom'
          }, r.props)));
        });
      };

      rows.forEach(function (row, i) {
        if ((0, _lodash.has)(_this2.props.customRows, i)) {
          appendCustomRow(rowsWithCustomRows, _this2.props.customRows[i], i);
        }
        rowsWithCustomRows.push(row);
      });

      if ((0, _lodash.has)(this.props.customRows, -1)) {
        appendCustomRow(rowsWithCustomRows, this.props.customRows[-1], -1);
      }

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-table-body'), ref: this.bodyRef },
        rowsWithCustomRows
      );
    }
  }, {
    key: 'renderSelectColumn',
    value: function renderSelectColumn() {
      var _this3 = this;

      var isSelected = this.props.isSelected;

      // Using the onClick callback we prevent the onClick on the table rows
      // to be triggered when the checkbox is clicked.

      return _react2.default.createElement(_TableColumn2.default, {
        width: 50,
        builder: function builder(datum) {
          var selected = isSelected ? isSelected(datum) : false;
          return _react2.default.createElement('input', {
            type: 'checkbox',
            checked: selected,
            onClick: function onClick(event) {
              return event.stopPropagation();
            },
            onChange: function onChange(event) {
              return _this3.onSelectRow(event, datum);
            }
          });
        }
      });
    }
  }, {
    key: 'renderOrderColumn',
    value: function renderOrderColumn() {
      return _react2.default.createElement(_TableColumn2.default, {
        width: 100,
        title: _react2.default.createElement(_Icon.Icon, { name: 'arrows-v' }),
        builder: this.renderOrderCell,
        center: true
      });
    }
  }, {
    key: 'renderExpandColumn',
    value: function renderExpandColumn() {
      var _this4 = this;

      var builder = function builder(datum) {
        var onClick = function onClick() {
          return _this4.onExpandClick(datum);
        };

        var index = _this4.getExpansionIndex(datum);
        var isExpanding = _this4.isExpanding(index);
        var isExpanded = _this4.isExpanded(index);

        return _react2.default.createElement(
          'div',
          { className: 'ui-table-row-expand-trigger', tabIndex: 0, onClick: onClick },
          !isExpanding && !isExpanded && _react2.default.createElement(_Icon.Icon, { name: 'plus-square-o' }),
          isExpanding && _react2.default.createElement(_Spinner.Spinner, null),
          !isExpanding && isExpanded && _react2.default.createElement(_Icon.Icon, { name: 'minus-square-o' })
        );
      };

      return _react2.default.createElement(_TableColumn2.default, { width: 50, builder: builder, center: true, expander: true });
    }
  }, {
    key: 'renderPagination',
    value: function renderPagination() {
      var _this5 = this;

      var _props3 = this.props,
          pages = _props3.pages,
          page = _props3.page,
          onPaginate = _props3.onPaginate;
      var paginating = this.state.paginating;


      if (!onPaginate) {
        return null;
      }

      // If an onPaginate handler is given, build a wrapper that changes the
      // state
      var onPaginateWrapper = function onPaginateWrapper(p) {
        _this5.setState({ expansions: {}, expanding: [], paginating: true }, function () {
          var result = _this5.props.onPaginate(p);

          // Check if the result is a promise. If so, wait for it to be
          // fulfilled before updating the internal state.
          if ((0, _utils.isPromise)(result)) {
            result.then(function () {
              return _this5.setState({ paginating: false });
            });
          } else {
            _this5.setState({ paginating: true });
          }
        });
      };

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-table-footer-pagination') },
        _react2.default.createElement(_Pagination.Pagination, {
          current: page,
          count: pages,
          disabled: paginating,
          onClick: onPaginateWrapper
        })
      );
    }

    // Filter only Table Columns.
    // If the table is mass selectable we inject a checkbox column

  }, {
    key: 'renderColumns',
    value: function renderColumns() {
      var columns = [].concat(this.props.children).filter(function (child) {
        return (0, _lodash.get)(child, 'type') === _TableColumn2.default;
      });

      // Prepend the checkbox column
      if (this.isSelectable()) {
        columns.unshift(this.renderSelectColumn());
      }

      // Prepend the order column
      if (this.isOrderable()) {
        columns.unshift(this.renderOrderColumn());
      }

      // Prepend the order column
      if (this.isExpandable()) {
        columns.unshift(this.renderExpandColumn());
      }

      return columns;
    }
  }, {
    key: 'renderPageSizes',
    value: function renderPageSizes() {
      var _this6 = this;

      var _props4 = this.props,
          onPaginate = _props4.onPaginate,
          pageSizes = _props4.pageSizes,
          pageSize = _props4.pageSize;


      if (onPaginate && pageSizes) {
        return _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-table-footer-page-sizes') },
          pageSizes.map(function (size, index) {
            return _react2.default.createElement(
              'a',
              {
                key: index,
                tabIndex: index,
                onClick: function onClick() {
                  return _this6.onPageSizeChange(size);
                },
                className: (0, _classnames2.default)('ui-table-footer-page-size', {
                  'ui-table-footer-page-size-active': size === pageSize
                })
              },
              size
            );
          })
        );
      }

      return null;
    }
  }, {
    key: 'renderFooter',
    value: function renderFooter() {
      var footer = this.props.footer;

      var pagination = this.renderPagination();
      var pageSizes = this.renderPageSizes();

      if (pagination || pageSizes || footer) {
        return _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-table-footer') },
          pagination,
          pageSizes,
          footer
        );
      }

      return null;
    }
  }, {
    key: 'renderPrefix',
    value: function renderPrefix() {
      var prefix = this.props.prefix;


      if (prefix) {
        return _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-table-prefix') },
          this.props.prefix
        );
      }

      return null;
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader(columns) {
      var headerRow = this.renderHeaderRow(columns);

      if (this.props.noHeader) {
        return null;
      }

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-table-header') },
        headerRow
      );
    }
  }, {
    key: 'renderTitle',
    value: function renderTitle() {
      var title = this.props.title;


      return title && _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-table-title') },
        title
      );
    }
  }, {
    key: 'renderError',
    value: function renderError() {
      var error = this.props.error;


      return error && _react2.default.createElement(
        'div',
        { className: 'ui-table-errors' },
        error
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props5 = this.props,
          loading = _props5.loading,
          embedded = _props5.embedded,
          margin = _props5.margin,
          responsive = _props5.responsive;


      var columns = this.renderColumns();
      var style = (0, _utils2.spacingStyles)({ margin: margin });
      var tableClassName = (0, _classnames2.default)('ui-table-wrapper', {
        'ui-table-loading': loading,
        'ui-table-embedded': embedded,
        'ui-table-responsive': responsive
      });

      return _react2.default.createElement(
        'div',
        { className: tableClassName, style: style },
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-table-overlay') },
          _react2.default.createElement(_Spinner.Spinner, null)
        ),
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-table') },
          this.renderTitle(),
          this.renderPrefix(),
          this.renderHeader(columns),
          this.renderDataRows(columns),
          this.renderError(),
          this.renderEmptyBody(),
          this.renderFooter()
        )
      );
    }
  }]);

  return Table;
}(_react.Component);

Table.propTypes = {
  children: _react2.default.PropTypes.node,

  // If this prop is specified, the rows will be inserted at the indexes
  // represented by the prop keys. Use the key -1 to append lines
  // at the end. Example:
  //
  // {
  //   3: <TableRow ... />,
  //   5: [<TableRow ... />, <TableRow ... />],
  //   -1: <TableRow ... />,
  // }
  //
  // This inserts one row after index 3, two after index 5 and one at the end.
  customRows: _react2.default.PropTypes.object,

  // The actual data which is displayed
  data: _react2.default.PropTypes.array.isRequired,

  // This adds just a class to the table. It says that the table is embedded
  // into something, e.g. a box. It then can react on that and adjust the style
  // for example.
  embedded: _react2.default.PropTypes.bool,

  // Something which is displayed in the table footer
  footer: _react2.default.PropTypes.node,

  // A function which return if a given row is highlighted
  highlighted: _react2.default.PropTypes.func,

  // Specifies if the table is in loading mode
  loading: _react2.default.PropTypes.bool,

  // Enable scroll-x when table so long
  responsive: _react2.default.PropTypes.bool,

  onPageSizeChange: _react2.default.PropTypes.func,
  onPaginate: _react2.default.PropTypes.func,
  page: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string]),
  pages: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string]),
  pageSize: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string]),
  pageSizes: _react2.default.PropTypes.array,
  prefix: _react2.default.PropTypes.node,
  title: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.bool]),
  addonBuilder: _react2.default.PropTypes.func,
  noHeader: _react2.default.PropTypes.bool,

  // If specified, the table columns are orderable by the user.
  // On drag release this callback is invoked and receives the an array containing
  // the objects in the new order.
  onOrder: _react2.default.PropTypes.func,

  // If this is specified the table is assumed to be mass-selectable.
  // For that a column is injected which contains a checkbox.
  onSelect: _react2.default.PropTypes.func,

  // If true, an onRowClickHandler will be set automatically, that selects
  // the clicked row.
  selectOnRowClick: _react2.default.PropTypes.bool,

  // A function which returns if a specific datum is selected
  isSelected: _react2.default.PropTypes.func,

  margin: _react2.default.PropTypes.string,
  error: _react2.default.PropTypes.node,
  emptyBody: _react2.default.PropTypes.func,

  // If defined, the table rows are expandable
  onExpand: _react2.default.PropTypes.func,

  /**
   * Triggered when a datum was updated by the table. Us this to update the data
   * prop and trigger a re-render.
   */
  onUpdate: _react2.default.PropTypes.func,

  /**
   * If specified, this is used to validate inline-edit data.
   */
  onValidate: _react2.default.PropTypes.func,

  cancelLabel: _react2.default.PropTypes.string.isRequired
};
Table.defaultProps = {
  data: [],
  onExpand: null,
  onOrder: null,
  onUpdate: null,
  onValidate: null,
  cancelLabel: 'Cancel'
};
exports.default = Table;