'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TableColumn = function TableColumn() {};

TableColumn.propTypes = {
  attribute: _react2.default.PropTypes.string,
  bold: _react2.default.PropTypes.bool,
  builder: _react2.default.PropTypes.func,
  center: _react2.default.PropTypes.bool,
  copyable: _react2.default.PropTypes.bool,
  formatter: _react2.default.PropTypes.shape({ format: _react2.default.PropTypes.func.isRequired }),
  icon: _react2.default.PropTypes.string,
  onSort: _react2.default.PropTypes.func,
  orderHandle: _react2.default.PropTypes.bool,
  right: _react2.default.PropTypes.bool,
  expander: _react2.default.PropTypes.bool,
  title: _react2.default.PropTypes.node,
  width: _react2.default.PropTypes.number,
  customClass: _react2.default.PropTypes.string,
  breakCell: _react2.default.PropTypes.bool,

  /**
   * If specified, makes the cells in this column inline editable. This callback is called
   * on edit commit.
   * If no `editable` prop is defined, the stringified cell content is used as
   * editable value.
   *
   * @type {function}
   */
  onEdit: _react2.default.PropTypes.func,

  /**
   * If this is specified, it is used as key to fetch the editable value.
   *
   * @type {string}
   */
  editable: _react2.default.PropTypes.string
};

TableColumn.defaultProps = {
  expander: false
};

exports.default = TableColumn;