'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _utils = require('../../utils');

var _Tab = require('./Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Icon = require('../Icon');

var _Badge = require('../Badge');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tabs = function (_Component) {
  _inherits(Tabs, _Component);

  function Tabs() {
    _classCallCheck(this, Tabs);

    return _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).apply(this, arguments));
  }

  _createClass(Tabs, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      var activeTab = (0, _lodash.find)(this.props.children, function (c) {
        return (0, _lodash.get)(c, 'props.name') === _this2.props.active;
      });

      this.setState({
        activeIndex: activeTab ? this.props.children.indexOf(activeTab) : 0
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var children = [].concat(this.props.children).filter(function (child) {
        return !(0, _lodash.isNull)(child) && child !== false;
      }).map(function (child, index) {
        return _react2.default.createElement(_Tab2.default, _extends({
          key: index
        }, (0, _utils.merge)(child.props, {
          active: child.props.active || child.props.name === _this3.props.active,
          onSelect: function onSelect() {
            if (index !== _this3.state.activeIndex) {
              var nameOrIndex = child.props.name || index;
              if (_this3.props.onChange) {
                _this3.props.onChange(nameOrIndex);
              }

              if (child.props.onSelect) {
                child.props.onSelect(nameOrIndex);
              }

              _this3.setState({
                activeIndex: index
              });
            }
          }
        })));
      });

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('ui-tabs', {
            'ui-tabs-embedded': this.props.embedded
          })
        },
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-tabs-headers') },
          children.map(function (child, index) {
            return _react2.default.createElement(
              'a',
              {
                key: index,
                tabIndex: index,
                onClick: function onClick() {
                  if (child.props.disabled === false) {
                    child.props.onSelect();
                  }
                },
                className: (0, _classnames2.default)('ui-tab-header', {
                  'ui-tab-header-active': child.props.active,
                  'ui-tab-header-disabled': child.props.disabled
                })
              },
              child.props.icon ? _react2.default.createElement(_Icon.Icon, { name: child.props.icon }) : null,
              child.props.title,
              child.props.badge ? _react2.default.createElement(
                _Badge.Badge,
                { margin: '1xl', state: 'info' },
                child.props.badge
              ) : null,
              child.props.image ? _react2.default.createElement('img', {
                className: 'ui-tab-header-image',
                src: child.props.image,
                role: 'presentation'
              }) : null
            );
          })
        ),
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-tabs-contents') },
          children
        )
      );
    }
  }]);

  return Tabs;
}(_react.Component);

Tabs.propTypes = {
  children: _react2.default.PropTypes.node,
  embedded: _react2.default.PropTypes.bool,

  // Name of the active tab (optional)
  active: _react2.default.PropTypes.string,

  // Called when the tab changes
  onChange: _react2.default.PropTypes.func
};

Tabs.defaultProps = {};

exports.default = Tabs;