'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Tag(_ref) {
  var children = _ref.children,
      onRemove = _ref.onRemove;

  var removeButton = onRemove && _react2.default.createElement(
    'div',
    { className: (0, _classnames2.default)('ui-tag-addon') },
    _react2.default.createElement(_Button.Button, { icon: 'trash', onClick: onRemove })
  );

  return _react2.default.createElement(
    'div',
    { className: (0, _classnames2.default)('ui-tag') },
    _react2.default.createElement(
      'div',
      { className: 'ui-tag-inner' },
      _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-tag-content') },
        children
      ),
      removeButton
    )
  );
}

Tag.propTypes = {
  /**
   * The tag content
   * @type {Object}
   */
  children: _react2.default.PropTypes.any,

  /**
   * When provided, a little remove button is rendered and triggers
   * this callback
   * @type {Function}
   */
  onRemove: _react2.default.PropTypes.func
};

exports.default = Tag;