'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../Spacing/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Text(props) {
  var block = props.block,
      bold = props.bold,
      center = props.center,
      children = props.children,
      margin = props.margin,
      muted = props.muted,
      padding = props.padding,
      small = props.small,
      theme = props.theme,
      left = props.left,
      right = props.right,
      italic = props.italic,
      large = props.large;


  var style = (0, _utils.spacingStyles)({ margin: margin, padding: padding });
  var classNames = (0, _classnames2.default)('ui-text', 'ui-text-theme-' + theme, {
    'ui-text-muted': muted,
    'ui-text-bold': bold,
    'ui-text-small': small,
    'ui-align-center': center,
    'ui-align-left': left,
    'ui-align-right': right,
    'ui-text-font-italic': italic,
    'ui-text-large': large
  });

  return block ? _react2.default.createElement(
    'div',
    { className: classNames, style: style },
    children
  ) : _react2.default.createElement(
    'span',
    { className: classNames, style: style },
    children
  );
}

Text.propTypes = {
  muted: _react2.default.PropTypes.bool,
  block: _react2.default.PropTypes.bool,
  children: _react2.default.PropTypes.node,
  bold: _react2.default.PropTypes.bool,
  margin: _react2.default.PropTypes.string,
  padding: _react2.default.PropTypes.string,
  small: _react2.default.PropTypes.bool,
  center: _react2.default.PropTypes.bool,
  theme: _react2.default.PropTypes.oneOf(['default', 'success', 'light']),
  left: _react2.default.PropTypes.bool,
  right: _react2.default.PropTypes.bool,
  italic: _react2.default.PropTypes.bool,
  large: _react2.default.PropTypes.bool
};

Text.defaultProps = {
  theme: 'default'
};

exports.default = Text;