'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Thumbnail(_ref) {
  var src = _ref.src,
      label = _ref.label,
      circle = _ref.circle,
      inline = _ref.inline,
      width = _ref.width;

  var className = (0, _classnames2.default)('ui-thumbnail', {
    'ui-thumbnail-circle': circle,
    'ui-thumbnail-inline': inline
  });

  var style = {};

  if (width) {
    style.width = width + 'px';
  }

  return _react2.default.createElement(
    'div',
    { className: className },
    label && _react2.default.createElement(
      'div',
      { className: 'ui-thumbnail-label' },
      label
    ),
    _react2.default.createElement('img', { src: src, role: 'presentation', style: style })
  );
}

Thumbnail.propTypes = {
  circle: _react2.default.PropTypes.bool,
  inline: _react2.default.PropTypes.bool,
  label: _react2.default.PropTypes.string,
  src: _react2.default.PropTypes.string.isRequired,
  width: _react2.default.PropTypes.number
};

exports.default = Thumbnail;