'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TimelineItem = function TimelineItem(props) {
  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames2.default)('ui-timeline-item', {
        'ui-timeline-item-highlighted': props.highlighted
      })
    },
    _react2.default.createElement('div', { className: (0, _classnames2.default)('ui-timeline-line') }),
    props.icon ? _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('ui-timeline-item-icon') },
      _react2.default.createElement(_Icon.Icon, { name: props.icon })
    ) : null,
    _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('ui-timeline-item-content') },
      props.title ? _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-timeline-item-title') },
        props.title
      ) : null,
      props.date ? _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-timeline-item-date') },
        props.date
      ) : null,
      !(0, _lodash.isEmpty)(props.description) ? _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-timeline-item-description') },
        props.description
      ) : null
    )
  );
};

TimelineItem.propTypes = {
  title: _react2.default.PropTypes.string,
  date: _react2.default.PropTypes.string,
  description: _react2.default.PropTypes.string,
  icon: _react2.default.PropTypes.string,
  highlighted: _react2.default.PropTypes.bool
};

exports.default = TimelineItem;