'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../Icon');

var _Flex = require('../Flex');

var _Spacing = require('../Spacing');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Transfer(_ref) {
  var from = _ref.from,
      to = _ref.to,
      margin = _ref.margin;

  return _react2.default.createElement(
    _Spacing.Spacing,
    { margin: margin },
    _react2.default.createElement(
      'div',
      { className: 'ui-transfer' },
      _react2.default.createElement(
        _Flex.Flex,
        null,
        _react2.default.createElement(
          _Flex.FlexItem,
          { widths: { md: 4 } },
          from
        ),
        _react2.default.createElement(
          _Flex.FlexItem,
          { widths: { md: 4 } },
          _react2.default.createElement(_Icon.Icon, { name: 'angle-double-right', className: 'ui-transfer-icon' })
        ),
        _react2.default.createElement(
          _Flex.FlexItem,
          { widths: { md: 4 } },
          to
        )
      )
    )
  );
}

Transfer.propTypes = {
  from: _react2.default.PropTypes.node,
  to: _react2.default.PropTypes.node,
  margin: _react2.default.PropTypes.string
};

exports.default = Transfer;