'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TreeItem = require('./TreeItem');

var _TreeItem2 = _interopRequireDefault(_TreeItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tree = function (_React$Component) {
  _inherits(Tree, _React$Component);

  function Tree(props) {
    _classCallCheck(this, Tree);

    var _this = _possibleConstructorReturn(this, (Tree.__proto__ || Object.getPrototypeOf(Tree)).call(this, props));

    _this.renderNode = function (node, index) {
      var _this$props = _this.props,
          onItemClick = _this$props.onItemClick,
          levelPrefix = _this$props.levelPrefix,
          maxDepth = _this$props.maxDepth,
          itemAddon = _this$props.itemAddon,
          highlighted = _this$props.highlighted;
      var childs = node.childs,
          depth = node.depth,
          expanded = node.expanded,
          label = node.label;


      return _react2.default.createElement(_TreeItem2.default, {
        label: label,
        depth: depth,
        key: index,
        expanded: expanded,
        childs: childs,
        onClick: onItemClick,
        node: node,
        levelPrefix: levelPrefix,
        maxDepth: maxDepth,
        itemAddon: itemAddon,
        highlighted: highlighted
      });
    };

    var data = props.data;


    _this.state = {
      data: data
    };
    return _this;
  }

  _createClass(Tree, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var data = _ref.data;

      this.setState({ data: data });
    }
  }, {
    key: 'renderLevelPrefix',
    value: function renderLevelPrefix() {
      var levelPrefix = this.props.levelPrefix;


      if (levelPrefix) {
        return levelPrefix(null, 0);
      }

      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.state.data;


      var nodes = [].concat(data);

      return _react2.default.createElement(
        'div',
        { className: 'ui-tree' },
        this.renderLevelPrefix(),
        nodes.map(this.renderNode)
      );
    }
  }]);

  return Tree;
}(_react2.default.Component);

Tree.propTypes = {
  // Tree data, see docs
  data: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.array, _react2.default.PropTypes.object]).isRequired,

  // Triggered on item click
  onItemClick: _react2.default.PropTypes.func.isRequired,

  // Rendered on each level once
  levelPrefix: _react2.default.PropTypes.func,

  // maximum tree depth
  maxDepth: _react2.default.PropTypes.number,

  // Rendered on each item
  itemAddon: _react2.default.PropTypes.func,

  // Func that returns a boolean value indicating if a node should be highlighted
  highlighted: _react2.default.PropTypes.func
};
Tree.defaultProps = {
  levelPrefix: null,
  maxDepth: null,
  highlighted: null
};
exports.default = Tree;