'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('../Icon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TreeItem = function (_React$Component) {
  _inherits(TreeItem, _React$Component);

  function TreeItem(props) {
    _classCallCheck(this, TreeItem);

    var _this = _possibleConstructorReturn(this, (TreeItem.__proto__ || Object.getPrototypeOf(TreeItem)).call(this, props));

    var expanded = props.expanded;


    _this.state = {
      expanded: expanded
    };
    return _this;
  }

  _createClass(TreeItem, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          childs = _props.childs,
          depth = _props.depth,
          highlighted = _props.highlighted,
          itemAddon = _props.itemAddon,
          label = _props.label,
          levelPrefix = _props.levelPrefix,
          maxDepth = _props.maxDepth,
          node = _props.node,
          onClick = _props.onClick;
      var expanded = this.state.expanded;


      function iconName() {
        if (expanded) {
          return 'minus-square-o';
        }

        return 'plus-square';
      }

      var onExpandClick = function onExpandClick() {
        _this2.setState(function (state) {
          return { expanded: !state.expanded };
        });
      };

      function renderPrefix() {
        if (maxDepth && maxDepth === depth) {
          return null;
        }

        return _react2.default.createElement(
          'a',
          { className: 'ui-tree-item-prefix', onClick: onExpandClick, tabIndex: 0 },
          _react2.default.createElement(_Icon.Icon, { name: iconName() })
        );
      }

      var onClickWrapper = function onClickWrapper() {
        onClick(node);
      };

      var renderAddon = function renderAddon() {
        if (itemAddon) {
          var renderedAddon = itemAddon(node, depth);
          return renderedAddon && _react2.default.createElement(
            'div',
            { className: 'ui-tree-item-details-addon' },
            renderedAddon
          );
        }

        return null;
      };

      var renderBox = function renderBox() {
        var className = (0, _classnames2.default)('ui-tree-item-box', {
          'ui-tree-item-box-clickable': onClick
        });

        return _react2.default.createElement(
          'a',
          { className: className, tabIndex: 0, onClick: onClickWrapper },
          label
        );
      };

      var renderChild = function renderChild(_node, index) {
        return _react2.default.createElement(TreeItem, {
          label: _node.label,
          depth: _node.depth,
          expanded: _node.expanded,
          key: index,
          childs: _node.childs,
          onClick: onClick,
          node: _node,
          levelPrefix: levelPrefix,
          maxDepth: maxDepth,
          itemAddon: itemAddon,
          highlighted: highlighted
        });
      };

      var renderChilds = function renderChilds() {
        if (expanded) {
          return _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              'div',
              { className: 'ui-tree-item-indent' },
              levelPrefix && levelPrefix(node, depth + 1)
            ),
            _react2.default.createElement(
              'div',
              { className: 'ui-tree-item-childs' },
              childs.map(renderChild)
            )
          );
        }

        return null;
      };

      var className = (0, _classnames2.default)('ui-tree-item', {
        'ui-tree-item-expandable': true,
        'ui-tree-item-indent': depth > 0,
        'ui-tree-item-with-addon': itemAddon,
        'ui-tree-item-highlighted': highlighted && highlighted(node)
      });

      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement(
          'div',
          { className: 'ui-tree-item-details' },
          _react2.default.createElement(
            'div',
            { className: 'ui-tree-item-details-inner' },
            renderPrefix(),
            renderBox()
          ),
          renderAddon()
        ),
        _react2.default.createElement(
          'div',
          { className: 'ui-tree-item-childs' },
          renderChilds()
        )
      );
    }
  }]);

  return TreeItem;
}(_react2.default.Component);

TreeItem.propTypes = {
  label: _react2.default.PropTypes.string.isRequired,
  depth: _react2.default.PropTypes.number.isRequired,
  expanded: _react2.default.PropTypes.bool.isRequired,
  childs: _react2.default.PropTypes.array.isRequired,
  onClick: _react2.default.PropTypes.func.isRequired,
  node: _react2.default.PropTypes.object.isRequired,
  levelPrefix: _react2.default.PropTypes.func,
  maxDepth: _react2.default.PropTypes.number,
  itemAddon: _react2.default.PropTypes.func,
  highlighted: _react2.default.PropTypes.func
};
TreeItem.defaultProps = {
  levelPrefix: null,
  maxDepth: null,
  itemAddon: null,
  highlighted: null
};
exports.default = TreeItem;