'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _spaceable = require('../../decorators/spaceable');

var _spaceable2 = _interopRequireDefault(_spaceable);

var _alignable = require('../../decorators/alignable');

var _alignable2 = _interopRequireDefault(_alignable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Decorators
var Wrapper = function Wrapper(props) {
  var children = props.children;
  var accent = props.accent;
  var highlight = props.highlight;
  var fullheight = props.fullheight;

  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames2.default)('ui-wrapper', {
        'ui-wrapper-accent': accent,
        'ui-wrapper-highlight': highlight,
        'ui-wrapper-fullheight': fullheight
      })
    },
    children
  );
};

// Utils


Wrapper.propTypes = {
  accent: _react2.default.PropTypes.bool,
  highlight: _react2.default.PropTypes.bool,
  fullheight: _react2.default.PropTypes.bool,
  children: _react2.default.PropTypes.node
};

Wrapper.defaultProps = {};

exports.default = (0, _alignable2.default)((0, _spaceable2.default)(Wrapper));