'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var alignable = function alignable(Component) {
  var AlignableComponent = function AlignableComponent(props) {
    var align = props.align;
    if (align) {
      return _react2.default.createElement(
        Component,
        props,
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)('ui-align-' + align) },
          props.children
        )
      );
    }
    return _react2.default.createElement(Component, props);
  };

  AlignableComponent.propTypes = {
    align: _react2.default.PropTypes.oneOf(['left', 'center', 'right']),
    children: _react2.default.PropTypes.node
  };

  return AlignableComponent;
};

// Utils
exports.default = alignable;