'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var muteable = function muteable(Component) {
  var MuteableComponent = function MuteableComponent(props) {
    var classes = (0, _classnames2.default)({
      'ui-text-muted': props.muted,
      'ui-text-inverse': props.inverse,
      'ui-text-light': props.light,
      'ui-text-opaque': props.opaque,
      'ui-text-large': props.large
    });

    if (props.muted || props.inverse || props.large || props.opaque) {
      return _react2.default.createElement(
        Component,
        props,
        _react2.default.createElement(
          'div',
          { className: classes },
          props.children
        )
      );
    }
    return _react2.default.createElement(Component, props);
  };

  MuteableComponent.propTypes = {
    muted: _react2.default.PropTypes.bool,
    inverse: _react2.default.PropTypes.bool,
    light: _react2.default.PropTypes.bool,
    large: _react2.default.PropTypes.bool,
    opaque: _react2.default.PropTypes.bool,
    children: _react2.default.PropTypes.node
  };

  return MuteableComponent;
};

// Utils
exports.default = muteable;