'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Spacing = require('../components/Spacing');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var spaceable = function spaceable(Component) {
  var SpaceableComponent = function SpaceableComponent(props) {
    var padding = props.padding;
    var margin = props.margin;

    if (margin || padding) {
      var intermediate = _react2.default.createElement(Component, props);

      if (padding) {
        intermediate = _react2.default.createElement(
          Component,
          props,
          _react2.default.createElement(
            _Spacing.Spacing,
            { padding: padding },
            props.children
          )
        );
      }

      if (margin) {
        intermediate = _react2.default.createElement(
          _Spacing.Spacing,
          { margin: margin },
          intermediate
        );
      }

      return intermediate;
    }

    return _react2.default.createElement(Component, props);
  };

  SpaceableComponent.propTypes = {
    padding: _react2.default.PropTypes.string,
    margin: _react2.default.PropTypes.string,
    children: _react2.default.PropTypes.node
  };

  return SpaceableComponent;
};

exports.default = spaceable;