'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tweakable = function tweakable(Component) {
  var TweakableComponent = function TweakableComponent(props) {
    var result = _react2.default.createElement(Component, props);

    if (props.center) {
      result = _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('ui-align-center') },
        result
      );
    }

    return result;
  };

  TweakableComponent.propTypes = {
    // wraps the component into an alignment wrapper
    center: _react2.default.PropTypes.bool
  };

  return TweakableComponent;
};

// Utils
exports.default = tweakable;