'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../components/Spacing/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function spacable(Component) {
  var SpacableComponent = function SpacableComponent(_ref) {
    var margin = _ref.margin,
        padding = _ref.padding,
        rest = _objectWithoutProperties(_ref, ['margin', 'padding']);

    var style = (0, _utils.spacingStyles)({ margin: margin, padding: padding });
    var newProps = _extends({}, rest, { style: style });

    return _react2.default.createElement(Component, newProps);
  };

  SpacableComponent.propTypes = {
    margin: _react2.default.PropTypes.string,
    padding: _react2.default.PropTypes.string
  };

  SpacableComponent.defaultProps = {
    margin: null,
    padding: null
  };

  return SpacableComponent;
}

exports.default = spacable;