'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var childValidator = function childValidator(_ref) {
  var type = _ref.type;
  return function (props, propName, componentName) {
    var prop = props[propName];
    var error = null;

    _react2.default.Children.forEach(prop, function (child) {
      if (child.type !== type) {
        error = new Error(componentName + ' children must be of type ' + type + '.');
      }
    });

    return error;
  };
};

exports.default = childValidator;